Strict
Module rubux.xors3d
Import brl.blitz

ModuleInfo "Version: 1.14"
ModuleInfo "Module Author: FDsagizi ICQ: 433273898"
ModuleInfo "Module Author: Siarzhuk Piatrouski, Swargo Studio. ICQ: 178106496"
ModuleInfo "Module Author: MoKa (Maxim Miheyev) ICQ: 302733741"
ModuleInfo "Authors: Knightmare, Render, .Squid"
ModuleInfo "Site: xors3d.com"
ModuleInfo "Copyright: LGPL"

' Changes Log
Rem
	31.05.2009
	Engine version: 1.14
	
		Cleaning module code
	
		New Functions:
			xDIPCounter
			xSurfRendered
			xEntityRendered
			xEntityVisible
			xRenderShadows
			xLightShadowEpsilons
			xSetShadowShader
			xInitShadows
			xSetShadowParams
			xEntityCastShadows
			xEntityIsCaster
			xShadowPriority
			xLightEnableShadows
			xLightShadowsEnabled
			xInitDeferred
			xSetDeferredShaders
			xRenderWorldDeferred
			xClearLogString
			xGetLogString
			xSetLogLevel
			xSetLogTarget
			xGetLogLevel
			xGetLogTarget
			xCreateLog

	Module Updated by Knightmare, .Squid
End Rem

Rem
	27.04.2009
	Engine version: 1.13
		Function xUpdateInput() renamed to xUpdateIM()
	
		Function 	xTerrainSize() deleted
		
		New Functions:
			xJoyType
			xJoyDown
			xJoyHit
			xGetJoy
			xWaitJoy
			xJoyX
			xJoyY
			xJoyZ
			xJoyU
			xJoyV
			xJoyPitch
			xJoyYaw
			xJoyRoll
			xJoyHat
			xJoyXDir
			xJoyYDir
			xJoyZDir
			xJoyUDir
			xJoyVDir
			xFlushJoy
			xGetFunctionAddress
			xTerrainSizeX
			xTerrainSizeZ
			xCollisionTriangle
			xLoadTextureInThread
			xTextureLoaded
			xCreateThread
			xGetNumberRT
			xSetMRT
			xUnSetMRT
			xLoadTextureInRAM
			xCreateTextureFromRAM
			xDrawBBox
			xEnableEntityShader
			xEntityAmbientColor
			xEntityEmissiveColor
			xGetAlphaFunc
			xGetAlphaRef
			xGetAlphaSort
			xGetRenderWindow
			xGetSurfaceTexture
			xKeyUp
			xLine3d
			xLoadMeshAsync
			xLoadMeshInThread
			xLoadMeshWithChild
			xSetAlphaSort
			xSphereInFrustum
			xVideoInfo
			xWaitKey
			xSetEffectEntityTexture
			xSetParticleSize
			xParticleSize

	Module Updated by Knightmare
End Rem

' unofficial versions change? logs deleted

Extern "win32"
	Function FindWindowA%(class%,title$z)
	Function LoadLibraryA(lib$z)
	Function GetProcAddress:Byte Ptr(lib%,fname$z) 
End Extern

Global gXorsLibName$ = "Xors3D.dll"


'
Global xTextureFilter_(matchText:Byte Ptr, flags%) "win32"
Global xClearTextureFilters() "win32"
Global xSurfaceBonesArrayName_(surface%, baName:Byte Ptr) "win32"
Global xSetSurfaceEffect(surface%, effect%) "win32"
Global xSurfaceTechnique_(surface%, name:Byte Ptr) "win32"
Global xSurfaceEffectVectorArray_(surface%, name:Byte Ptr, value%, size%) "win32"
Global xSurfaceEffectTexture_(surface%, name:Byte Ptr, texture%, frame%) "win32"
Global xSurfaceEffectVector_(surface%, name:Byte Ptr, x#, y#, z#, w#) "win32"
Global xSurfaceEffectEntityTexture_(surface%, name:Byte Ptr, index%) "win32"
Global xSurfaceEffectInt_(surface%, name:Byte Ptr, value%) "win32"
Global xSurfaceEffectBool_(surface%, name:Byte Ptr, value%) "win32"
Global xSurfaceEffectFloat_(surface%, name:Byte Ptr, value#) "win32"
Global xSurfaceEffectIntArray_(surface%, name:Byte Ptr, value%, size%) "win32"
Global xSurfaceEffectFloatArray_(surface%, name:Byte Ptr, value%, size%) "win32"
Global xSurfaceEffectMatrixArray_(surface%, name:Byte Ptr, value%, size%) "win32"
Global xSurfaceEffectEntityMatrix_(surface%, name:Byte Ptr, matrix%) "win32"
Global xSurfaceEffectMatrixSemantic_(surface%, name:Byte Ptr, semantic%) "win32"
Global xDeleteSurfaceConstant_(surface%, name:Byte Ptr) "win32"
Global xClearSurfaceConstants(surface%) "win32"

' Main
' deferred render
Global xInitDeferred_(tex1%, tex2%, tex3%, tex4) "win32"
Global xSetDeferredShaders_(mrtShader:Byte Ptr, lightShader:Byte Ptr) "win32"
Global xRenderWorldDeferred_(texture%) "win32"

' shadow system
Global xRenderShadows(camera%, texture%) "win32"
Global xLightShadowEpsilons_(light%, eps1#, eps2#) "win32"
Global xSetShadowShader_(path:Byte Ptr) "win32"
Global xInitShadows_(dirSize%, spotSize%, pointSize%) "win32"
Global xSetShadowParams_(splitPlanes%, splitLambda#, useOrtho%, lightDist#) "win32"
Global xEntityCastShadows(entity%, light%, state%) "win32"
Global xEntityIsCaster%(entity%, light%) "win32"
Global xShadowPriority(prior%) "win32"
Global xLightEnableShadows(light%, state%) "win32"
Global xLightShadowsEnabled%(light%) "win32"

' misc
Global xDIPCounter%() "win32"
Global xSurfRendered%() "win32"
Global xEntityRendered%() "win32"
Global xEntityVisible%(entity%) "win32"

'LogSys
Global xCreateLog_%(target%, level%, filename:Byte Ptr) "win32"
Global xSetLogLevel(level%) "win32"
Global xSetLogTarget(target%) "win32"
Global xGetLogLevel%() "win32"
Global xGetLogTarget%() "win32"
Global xClearLogString() "win32"
Global xGetLogString_:Byte Ptr() "win32"

' Joystick
Global xJoyType_%(portID%) "win32"
Global xJoyDown_%(key%, portID%) "win32"
Global xJoyHit_%(key%, portID%) "win32"
Global xGetJoy_%(portID%) "win32"
Global xWaitJoy_%(portID%) "win32"
Global xJoyX_#(portID%) "win32"
Global xJoyY_#(portID%) "win32"
Global xJoyZ_#(portID%) "win32"
Global xJoyU_#(portID%) "win32"
Global xJoyV_#(portID%) "win32"
Global xJoyPitch_#(portID%) "win32"
Global xJoyYaw_#(portID%) "win32"
Global xJoyRoll_#(portID%) "win32"
Global xJoyHat_#(portID%) "win32"
Global xJoyXDir_%(portID%) "win32"
Global xJoyYDir_%(portID%) "win32"
Global xJoyZDir_%(portID%) "win32"
Global xJoyUDir_%(portID%) "win32"
Global xJoyVDir_%(portID%) "win32"
Global xFlushJoy() "win32"

'	Window
Global xAppTitle_(title:Byte Ptr) "win32"
Global xSetWND(hwnd%) "win32"
Global xSetRenderWindow(newWND%) "win32"
Global xWinMessage%(msgWin:Byte Ptr) "win32"
Global xGraphics3D_%(width%,Height%,depth%,mode%,vsync%) "win32"
Global xGraphicsWidth%() "win32"
Global xGraphicsHeight%() "win32"
Global xGraphicsDepth%() "win32"
Global xGetDevice%() "win32"
Global xLostDevice%() "win32"
Global xReleaseXors() "win32"
Global xGetFunctionAddress_%(msgWin:Byte Ptr) "win32"
Global xDrawBBox(draw%, zon%, r%, g%, b%, a%) "win32"
Global xGetRenderWindow%() "win32"

'	System
Global xShowPointer() "win32"
Global xHidePointer() "win32"

'	Info
Global xGetFPS%() "win32"
Global xTrisRendered%() "win32"
Global xCPUFamily%() "win32"
Global xCPUModel%() "win32"
Global xCPUName_:Byte Ptr() "win32"
Global xCPUSpeed%() "win32"
Global xCPUStepping%() "win32"
Global xCPUVendor_:Byte Ptr() "win32"
Global xGetAvailPageMem#() "win32"
Global xGetAvailPhysMem#() "win32"
Global xGetAvailVidLocalMem#() "win32"
Global xGetAvailVidMem#() "win32"
Global xGetAvailVidNonlocalMem#() "win32"
Global xGetTotalPageMem#() "win32"
Global xGetTotalPhysMem#() "win32"
Global xGetTotalVidLocalMem#() "win32"
Global xGetTotalVidMem#() "win32"
Global xGetTotalVidNonlocalMem#() "win32"
Global xVideoInfo_:Byte Ptr() "win32"

'	World
Global xRenderWorld_(tween%) "win32"
Global xUpdateWorld_(speed#) "win32"
Global xClearWorld(e%,b%,t%) "win32"

'	Screen
Global xClsColor(r%,g%,b%) "win32"
Global xCls() "win32"
Global xFlip() "win32"

'	Wireframe,Dither,AntiAlias
Global xWireframe(State%) "win32"
Global xDither(State%) "win32"
Global xGetMaxAntiAlias%() "win32"
Global xSetAntiAliasType(aaType%) "win32"
Global xAntiAlias(State%) "win32"



' Load Meshes
Global xLoadMesh_%(path:Byte Ptr,parent%) "win32"
Global xLoadDXmesh_%(path:Byte Ptr,optimizeType%,parent%) "win32"
Global xLoadAnimMesh_%(path:Byte Ptr,parent%) "win32"

' Entity Create
Global xCreateCube_%(parent%) "win32"
Global xCreateSphere_%(seg%,parent%) "win32"
Global xCreateCylinder_%(seg%,SOLID%,parent%) "win32"
Global xCreateCone_%(seg%,SOLID%,parent%) "win32"
Global xCreatePivot_%(parent%) "win32"
Global xCreate3DLine%(parent%) "win32"
Global x3DLinePoints(line%, x0#, y0#, z0#, x1#, y1#, z1#) "win32"
Global xLine3d(x1%,y1%,z1%,x2%,y2%,z2%,r%,g%,b%,a%,zon%) "win32"

' Mesh
Global xCreateMesh_%(parent%) "win32"
Global xCopyMesh_%(entity%,parent%) "win32"
Global xMakeSingleSurface%(entity%) "win32"
Global xAddMesh(dest%,src%) "win32"
Global xFlipMesh(entity%) "win32"
Global xScaleMesh(entity%,x#,y#,z#) "win32"
Global xRotateMesh(entity%,x#,y#,z#) "win32"
Global xPositionMesh(entity%,x#,y#,z#) "win32"
Global xMeshWidth#(entity%) "win32"
Global xMeshHeight#(entity%) "win32"
Global xMeshDepth#(entity%) "win32"
Global xSetNeedUpdateBoundingSphere(entity%,need%) "win32"
Global xSetMeshVNIB(entity%,nVB%,nNB%,nIB%,nPIB%,numVert%,numTris%) "win32"
Global xUpdateMeshVBPositions(entity%,posArray%) "win32"
Global xUpdateMeshVBNormals(entity%,normArray%) "win32"
Global xUpdateMeshIB(entity%,indexArray%) "win32"
Global xGetMeshVB:Byte Ptr(entity%) "win32"
Global xGetMeshIB:Byte Ptr(entity%) "win32"
Global xGetMeshVBSize%(entity%) "win32"
Global xGetMeshIBSize%(entity%) "win32"
Global xDeleteMeshVB(entity%) "win32"
Global xDeleteMeshIB(entity%) "win32"
Global xMeshesIntersect%(ent1%,ent2%) "win32"
Global xLoadMeshAsync_%(path:Byte Ptr, parent%) "win32"
Global xLoadMeshInThread_(path:Byte Ptr, parent%) "win32"
Global xLoadMeshWithChild_%(path:Byte Ptr, parent%) "win32"
			
' Entity Animation
Global xAnimate_(entity%,mode%,speed#,se%,trans%,root:Byte Ptr) "win32"
Global xLoadAnimSeq_%(entity%,path:Byte Ptr) "win32"
Global xExtractAnimSeq_%(entity%,ff%,fl%,seq%) "win32"
Global xAnimSeq_%(entity%,root:Byte Ptr) "win32"
Global xSetAnimTime_(entity%,time#,root:Byte Ptr) "win32"
Global xAnimTime_#(entity%,root:Byte Ptr) "win32"
Global xSetAnimSpeed_(entity%,speed#,rootBone:Byte Ptr) "win32"
Global xAnimSpeed_#(entity%,rootBone:Byte Ptr) "win32"
Global xAnimLength_#(entity%,root:Byte Ptr) "win32"
Global xAnimating_%(entity%,root:Byte Ptr) "win32"
Global xSetSkinningMethod(Method1%) "win32"
Global xSetBonesArrayName(entity%,baName:Byte Ptr) "win32"

' Entity Position
Global xPositionEntity_(entity%,x#,y#,z#,isGlobal%) "win32"
Global xMoveEntity_(entity%,x#,y#,z#,isGlobal%) "win32"
Global xTranslateEntity_(entity%,x#,y#,z#,isGlobal%) "win32"
Global xEntityX_#(entity%,isGlobal%) "win32"
Global xEntityY_#(entity%,isGlobal%) "win32"
Global xEntityZ_#(entity%,isGlobal%) "win32"
Global xUpdatePhysXPose%(entity%) "win32"

' Entity Size
Global xScaleEntity_(entity%,x#,y#,z#,isGlobal%) "win32"
Global xEntityScaleX#(ent%) "win32"
Global xEntityScaleY#(ent%) "win32"
Global xEntityScaleZ#(ent%) "win32"

' Entity Rotation
Global xRotateEntity_(entity%,x#,y#,z#,isGlobal%) "win32"
Global xTurnEntity_(entity%,x#,y#,z#,isGlobal%) "win32"
Global xPointEntity_(ent1%,ent2%,Roll#) "win32"
Global xEntityRoll_#(entity%,isGlobal%) "win32"
Global xEntityYaw_#(entity%,isGlobal%) "win32"
Global xEntityPitch_#(entity%,isGlobal%) "win32"
Global xDeltaPitch#(ent1%,ent2%) "win32"
Global xDeltaYaw#(ent1%,ent2%) "win32"

' Entity Other
Global xEntityParent_(entity%,parent%,isglobal%) "win32"
Global xGetParent%(entity%) "win32"
Global xEnableEntityShader(ent%, enable%) "win32"
Global xNameEntity(entity%,Name:Byte Ptr) "win32"
Global xEntityName_:Byte Ptr(entity%) "win32" 
Global xEntityAmbientColor(ent%, r#, g#, b#) "win32"
Global xEntityInView%(entity%,cam%) "win32"
Global xShowEntity(entity%) "win32"
Global xHideEntity(entity%) "win32"
Global xEntityEmissiveColor(ent%, r#, g#, b#) "win32"
Global xCopyEntity_%(entity%,parent%,cloneBuff%) "win32"
Global xFreeEntity(entity%) "win32"
Global xEntityClass_:Byte Ptr(entity%) "win32"
Global xSetFrustrumSphere(entity%,x#,y#,z#,r#) "win32"
Global xGetAlphaFunc%(ent%) "win32"
Global xGetAlphaRef%(ent%) "win32"
'Global xGetAlphaSort%(ent%) "win32"
'Global xSetAlphaSort(ent%, state%) "win32"
Global xSphereInFrustum%(cam%, x#, y#, z#, r#) "win32"

' Entity Brush
Global xEntityAlpha(entity%,alpha#) "win32"
Global xSetAlphaRef(ent%,val%) "win32"
Global xSetAlphaFunc(ent%,val%) "win32"
Global xGetEntityAlpha#(entity%) "win32"
Global xEntityColor(entity%,r#,g#,b#) "win32"
Global xEntityBlend(entity%,mode%) "win32"
Global xEntityFX(entity%,fx%) "win32"
Global xEntityOrder(entity%,order%) "win32"
Global xEntityDistance#(ent1%,ent2%) "win32"
Global xEntitySpecularColor(entity%,r%,g%,b%) "win32"
Global xEntityAutoFade(entity%,near#,far#) "win32"
Global xEntityShininess(entity%,s#) "win32"

' Entity Childs
Global xCountChildren%(entity%) "win32"
Global xGetChild%(entity%,index%) "win32"
Global xFindChild%(entity%,Name:Byte Ptr) "win32"

' Entity Pick
Global xEntityPickMode_(entity%,mode%,obsc%) "win32"
Global xEntityPick%(entity%,Range%) "win32"

'   Group
Global xCreateGroup%() "win32"
Global xGroupAddEntity(eGroup%, ent%) "win32"
Global xRenderGroup(eGroup%) "win32"
Global xGroupRemoveEntity(eGroup%, ent%) "win32"	

' Input
Global xUpdateIM() "win32"
'	Mouse
Global xMouseDown%(Key%) "win32"
Global xMouseX%() "win32"
Global xMouseY%() "win32"
Global xMouseZ%() "win32"
Global xMouseXSpeed%() "win32"
Global xMouseYSpeed%() "win32"
Global xMouseZSpeed%() "win32"
Global xMoveMouse(x%,y%) "win32"
Global xMouseHit%(Key%) "win32"
'	Keyboard
Global xKeyHit%(Key%) "win32"
Global xKeyDown%(Key%) "win32"
Global xGetKey%() "win32"
Global xKey(Key:Byte Ptr) "win32"
Global xKeyUp%(key%) "win32"
Global xWaitKey() "win32"

' Camera
Global xCreateCamera_%(parent%) "win32"
Global xCameraProjMode(cam%,mode%) "win32"
Global xCameraViewport(cam%,x%,y%,w%,h%) "win32"
Global xCameraRange(cam%,n#,f#) "win32"
Global xCameraZoom(cam%,zoom#) "win32"
Global xCameraFogMode(cam%,mode%) "win32"
Global xCameraFogRange(cam%,near#,far#) "win32"
Global xCameraFogColor(cam%,r#,g#,b#) "win32"
Global xCameraClsColor(cam%,r#,g#,b#) "win32"
Global xCameraClsMode(cam%,cls_color%,cls_zbuffer%) "win32"

Global xCameraPick%(cam%,x#,y#) "win32"
Global xCameraProject(cam%,x#,y#,z#) "win32"
Global xProjectedX#() "win32"
Global xProjectedY#() "win32"
Global xProjectedZ#() "win32"


' Image
'	Image: Create,Load,Save,Free
Global xCreateImage_%(w%,h%,f%) "win32"
Global xLoadImage%(path:Byte Ptr) "win32"
Global xLoadAnimImage%(path:Byte Ptr,w%,h%,sf%,frames%) "win32"
Global xSaveImage_(img%,path:Byte Ptr,Frame%) "win32"
Global xFreeImage(entity%) "win32"
'	Image Draw
Global xDrawImage_(img%,x%,y%,Frame%) "win32"
Global xDrawImageRect_(img%,x%,y%,rx%,ry%,rw%,rh%,Frame%) "win32"
Global xTileImage_(img%,x%,y%,f%) "win32"
'	Image Manipulate
Global xScaleImage(img%,x#,y#) "win32"
Global xRotateImage(img%,a#) "win32"
Global xImageWidth%(img%) "win32"
Global xImageHeight%(img%) "win32"
'	Image Handle
Global xMidHandle(img%) "win32"
Global xAutoMidHandle(state%) "win32"
Global xHandleImage(img%,x%,y%) "win32"
Global xImageXHandle%(img%) "win32"
Global xImageYHandle%(img%) "win32"
'	Image Collision
Global xImagesCollide%(img1%,x1%,y1%,f1%,img2%,x2%,y2%,f2%) "win32"
Global xImagesOverlap(img1%,x1%,y1%,img2%,x2%,y2%) "win32"
Global xImageRectCollide(img1%,x%,y%,f%,rx%,ry%,rw%,rh%) "win32"
Global xImageRectOverlap(img1%,x%,y%,rx%,ry%,rw%,rh%) "win32"

' Pixels
Global xWritePixel_(x%,y%,argb%,buff%) "win32"
Global xWritePixelFast_(x%,y%,argb%,buff%) "win32"
Global xReadPixel_:Long(x%,y%,buff%) "win32"
Global xReadPixelFast_%(x%,y%,buff%) "win32"
Global xCopyPixel_(sx%,sy%,sbuf%,dx%,dy%,dbuf%) "win32"
Global xCopyPixelFast_(sx%,sy%,sbuf%,dx%,dy%,dbuf%) "win32"
Global xGetColor%(x%,y%) "win32"
Global xColorRed%() "win32"
Global xColorBlue%() "win32"
Global xColorGreen%() "win32"

' 2D
Global xColor(r%,g%,b%) "win32"
Global xRect_(x1%,y1%,x2%,y2%,SOLID%) "win32"
Global xOval_(x%,y%,w%,h%,SOLID%) "win32"
Global xLine(x1%,y1%,x2%,y2%) "win32"
Global xOrigin(x%,y%) "win32"

' Text
Global xLoadFont_%(FONT:Byte Ptr,Height%,bold%,italic%,underline%) "win32"
Global xSetFont(FONT%) "win32"
Global xFontWidth%() "win32"
Global xFontHeight%() "win32"
Global xFreeFont(FONT%) "win32"
Global xStringWidth%(tText:Byte Ptr) "win32"
Global xStringHeight%(tText:Byte Ptr) "win32"
Global xText_(x%,y%,dText:Byte Ptr,cx%,cy%) "win32"


' Rect
Global xCopyRect(sx%,sy%,sw%,sh%,dx%,dy%,sbuff%,dbuff%) "win32"
Global xStretchRect(sTexture%,sx%,sy%,sw%,sh%,dTexture%,dx%,dy%,dw%,dh%,filter%) "win32"
Global xStretchBackBuffer(dTexture%,x%,y%,w%,h%,filter%) "win32"


' Collision
Global xCollisions(srcType%,destType%,Method1%,response%) "win32"
Global xEntityType(entity%,cType%,recurse%) "win32"
Global xGetEntityType%(entity%) "win32"
Global xEntityRadius(entity%,x#) "win32"
'	Collision Contacts
Global xCountCollisions%(entity%) "win32"
Global xCollisionX#(entity%,index%) "win32"
Global xCollisionY#(entity%,index%) "win32"
Global xCollisionZ#(entity%,index%) "win32"
Global xCollisionNX#(entity%,index%) "win32"
Global xCollisionNY#(entity%,index%) "win32"
Global xCollisionNZ#(entity%,index%) "win32"
Global xCollisionTime%(entity%,index%) "win32"
Global xCollisionEntity%(entity%,index%) "win32"
Global xCollisionSurface%(entity%,index%) "win32"
Global xEntityBox(entity%,x#,y#,z#,w#,h#,d#) "win32"
Global xCollisionTriangle%(ent%,index%) "win32"

' Particle System
Global xCreateParticleSystem_%(tex%,Frame%,minps#,maxps#,parent%) "win32"
Global xParticleSystemTexture_(entity%,tex%,Frame%) "win32"
Global xCreateParticle_%(psys%,plife%) "win32"
Global xPositionParticle(psys%,pid%,x#,y#,z#) "win32"
Global xMoveParticle(psys%,pid%,x#,y#,z#) "win32"
Global xParticleX#(psys%,pid%) "win32"
Global xParticleY#(psys%,pid%) "win32"
Global xParticleZ#(psys%,pid%) "win32"
Global xParticleDX#(psys%,pid%) "win32"
Global xParticleDY#(psys%,pid%) "win32"
Global xParticleDZ#(psys%,pid%) "win32"
Global xParticleDirection(psys%,pid%,x#,y#,z#) "win32"
Global xSetParticleAge(psys%,pid%,age%) "win32"
Global xParticleAge%(psys%,pid%) "win32"
Global xSetParticleAcceleration(psys%,pid%,acl#) "win32"
Global xParticleAcceleration#(psys%,pid%) "win32"
Global xSetParticleVelocity(psys%,pid%,vel#) "win32"
Global xParticleVelocity#(psys%,pid%) "win32"
Global xParticlesCounter%(psys%) "win32"
Global xParticleColor(psys%,pid%,r%,g%,b%) "win32"
Global xParticleRed%(psys%,pid%) "win32"
Global xParticleGreen%(psys%,pid%) "win32"
Global xParticleBlue%(psys%,pid%) "win32"
Global xFreeParticle(psys%,pid%) "win32"
Global xSetParticleSize(psys%, pid%, size#) "win32"
Global xParticleSize#(psys%, pid%) "win32"

' Surface
Global xCreateSurface_%(MESH%,brush%) "win32"
Global xClearSurface_(surf%,verts%,tris%) "win32"
Global xCountSurfaces%(MESH%) "win32"
Global xGetSurface%(MESH%,index%) "win32"
Global xFindSurface%(MESH%,brush%) "win32"
Global xGetSurfaceBrush%(surf%) "win32"
Global xPaintSurface(surf%,brush%) "win32"
Global xUpdateNormals(MESH%) "win32"
Global xGetSurfaceTexture%(sur%, index%) "win32"

' Vertices
Global xAddVertex_%(surf%,x#,y#,z#,u#,v#,w#) "win32"
Global xAddTriangle%(surf%,v0%,v1%,v2%) "win32"
Global xTriangleVertex%(surf%,tid%,coner%) "win32"
Global xCountVertices%(surf%) "win32"
Global xCountTriangles%(surf%) "win32"
Global xVertexTexCoords_(surf%,ver%,u#,v#,w#,tset%) "win32"
Global xVertexU_#(surf%,vert%,tset%) "win32"
Global xVertexV_#(surf%,vert%,tset%) "win32"
Global xVertexW_#(surf%,vert%,tset%) "win32"
Global xVertexCoords(surf%,ver%,x#,y#,z#) "win32"
Global xVertexX#(surf%,vert%) "win32"
Global xVertexY#(surf%,vert%) "win32"
Global xVertexZ#(surf%,vert%) "win32"
Global xVertexNormal(surf%,ver%,nx#,ny#,nz#) "win32"
Global xVertexNX#(surf%,vert%) "win32"
Global xVertexNY#(surf%,vert%) "win32"
Global xVertexNZ#(surf%,vert%) "win32"
Global xVertexColor(surf%,ver%,r%,g%,b%,a#) "win32"
Global xVertexRed#(surf%,vert%) "win32"
Global xVertexGreen#(surf%,vert%) "win32"
Global xVertexBlue#(surf%,vert%) "win32"
Global xVertexAlpha#(surf%,vert%) "win32"


' Texture
Global xCreateTexture_%(w%,h%,fl%,fr%) "win32"
Global xLoadTexture_%(path:Byte Ptr,flag%) "win32"
Global xLoadAnimTexture%(path:Byte Ptr,flag%,w%,h%,ff%,tf%) "win32"
Global xFreeTexture(entity%) "win32"
Global xEntityTexture_(entity%,tex%,Frame%,index%) "win32"
Global xPositionTexture(tex%,x#,y#) "win32"
Global xRotateTexture(tex%,a#) "win32"
Global xScaleTexture(tex%,x#,y#) "win32"
Global xTextureWidth%(tex%) "win32"
Global xTextureHeight%(tex%) "win32"
Global xSetTextureFiltering(filter%) "win32"
Global xTextureBlend(tex%,blend%) "win32"
Global xTextureCoords(tex%,coords%) "win32"
Global xTextureName_:Byte Ptr(tex%) "win32"
Global xGetTextureSurface%(Texture%,Frame%) "win32"
Global xGetTextureFrames%(Texture%) "win32"
Global xSetCubeFace(tex%,face%) "win32"
Global xLoadTextureInThread_%(path:Byte Ptr, flag%) "win32"
Global xTextureLoaded%(tex%) "win32"
Global xCreateThread%(data%) "win32"
Global xGetNumberRT%() "win32"
Global xSetMRT(buffTex%, frame%, index%) "win32"
Global xUnSetMRT() "win32"
Global xLoadTextureInRAM_%(path:Byte Ptr) "win32"
Global xCreateTextureFromRAM%(tRAM%) "win32"

' Light
Global xCreateLight_%(lType%) "win32"
Global xAmbientLight(r%,g%,b%) "win32"
Global xLightRange(LIGHT%,Range#) "win32"
Global xLightColor(LIGHT%,r%,g%,b%) "win32"
Global xLightConeAngles(LIGHT%,inner#,outer#) "win32"


' Post Effect
'	1
Global xSetPostEffect_(peza%,index%) "win32"
Global xLoadPostEffect%(path:Byte Ptr,epoint:Byte Ptr,ver%) "win32"
Global xFreePostEffect(pe%) "win32"
Global xSetPostEffectInt(pe%,Name:Byte Ptr,Value%) "win32"
Global xSetPostEffectBool(pe%,Name:Byte Ptr,Value%) "win32"
Global xSetPostEffectFloat(pe%,Name:Byte Ptr,Value#) "win32"
Global xSetPostEffectVector_(pe%,Name:Byte Ptr,x#,y#,z#,w#) "win32"
Global xSetPostEffectDefaults(pe%) "win32"
Global xSetPostEffectTexture(pe%,Name:Byte Ptr,Value%) "win32"
Global xSetPostEffectBaseSampler(pe%,Name:Byte Ptr) "win32"
Global xSetPostEffectSceneSampler(pe%,sampler:Byte Ptr) "win32"
Global xSetPostEffectBaseSamplerScale(pe%,x#,y#) "win32"
Global xEnablePostProcessing(State%) "win32"
'	2
Global xCreatePoly%(sides%,par%) "win32"
Global xRenderPostEffect(poly%) "win32"
Global xCreatePostEffectPoly%(cam%,mode%) "win32"


' Pixel\Vertex Shader
Global xLoadVertexShader%(path:Byte Ptr,epoint:Byte Ptr,ver%) "win32"
Global xLoadPixelShader%(path:Byte Ptr,epoint:Byte Ptr,ver%) "win32"
Global xSetEntityVertexShader(entity%,shader%) "win32"
Global xSetEntityPixelShader(entity%,shader%) "win32"
Global xSetVertexShaderBool(entity%,Name:Byte Ptr,Value%) "win32"
Global xSetPixelShaderBool(entity%,Name:Byte Ptr,Value%) "win32"
Global xSetVertexShaderInt(entity%,Name:Byte Ptr,Value%) "win32"
Global xSetPixelShaderInt(entity%,Name:Byte Ptr,Value%) "win32"
Global xSetVertexShaderFloat(entity%,Name:Byte Ptr,Value#) "win32"
Global xSetPixelShaderFloat(entity%,Name:Byte Ptr,Value#) "win32"
Global xSetPixelShaderVector_(entity%,Name:Byte Ptr,x#,y#,z#,w#) "win32"
Global xSetVertexShaderVector_(entity%,Name:Byte Ptr,x#,y#,z#,w#) "win32"
Global xSetVertexShaderMatrix(entity%,Name:Byte Ptr,f11#,f12#,f13#,f14#,f21#,f22#,f23#,f24#,f31#,f32#,f33#,f34#,f41#,f42#,f43#,f44#) "win32"
Global xSetPixelShaderMatrix(entity%,Name:Byte Ptr,f11#,f12#,f13#,f14#,f21#,f22#,f23#,f24#,f31#,f32#,f33#,f34#,f41#,f42#,f43#,f44#) "win32"
Global xSetVertexShaderDefaults(shader%) "win32"
Global xSetPixelShaderDefaults(shader%) "win32"
Global xSetVertexShaderMatrixSemantic(entity%,Name:Byte Ptr,sem%) "win32"
Global xSetPixelShaderMatrixSemantic(entity%,Name:Byte Ptr,sem%) "win32"
Global xSetPixelShaderTexture_(entity%,Name:Byte Ptr,tex%,Frame%) "win32"
Global xSetPixelShaderEntityTexture_(entity%,Name:Byte Ptr,index%) "win32"
Global xDeleteVertexShaderConstant(entity%,Name:Byte Ptr) "win32"
Global xDeletePixelShaderConstant(entity%,Name:Byte Ptr) "win32"
Global xClearVertexShaderConstants(entity%) "win32"
Global xClearPixelShaderConstants(entity%) "win32"


' Shader
Global xGetMaxPixelShaderVersion%() "win32"
Global xGetMaxVertexShaderVersion%() "win32"
Global xEntityShader(entity%,mode%) "win32"


' Terrain
Global xLoadTerrain_%(path:Byte Ptr,parent%) "win32"
Global xModifyTerrain_(entity%,x%,y%,h#,rt%) "win32"
Global xCreateTerrain_%(Size%,parent%) "win32"
Global xTerrainShading(entity%,state%) "win32"
Global xTerrainHeight#(entity%,x%,y%) "win32"
Global xTerrainSizeX%(entity%) "win32"
Global xTerrainSizeZ%(entity%) "win32"
Global xTerrainX#(entity%,x#,y#,z#) "win32"
Global xTerrainY#(entity%,x#,y#,z#) "win32"
Global xTerrainZ#(entity%,x#,y#,z#) "win32"


' Brush
Global xCreateBrush_%(r#,g#,b#) "win32"
Global xLoadBrush_%(path:Byte Ptr,flags%,xs#,ys#) "win32"
Global xBrushTexture_(b%,t%,f%,i%) "win32"
Global xBrushColor(br%,r%,g%,b%) "win32"
Global xBrushAlpha(b%,a#) "win32"
Global xBrushShininess(b%,s#) "win32"
Global xBrushBlend(b%,bm%) "win32"
Global xBrushFX(b%,fx%) "win32"
Global xPaintEntity(entity%,brush%) "win32"
Global xGetBrushTexture%(brush%,index%) "win32"
Global xGetEntityBrush%(entity%) "win32"
Global xPaintMesh(entity%,brush%) "win32"
Global xFreeBrush(entity%) "win32"

' Buffer
Global xImageBuffer_%(img%,Frame%) "win32"
Global xTextureBuffer_%(tex%,Frame%) "win32"
Global xSaveBuffer(Buf%,path:Byte Ptr) "win32"
Global xLoadBuffer(Buf%,path:Byte Ptr) "win32"
Global xSetBuffer(Buf%) "win32"
Global xGraphicsBuffer%() "win32"
Global xBackBuffer%() "win32"
Global xLockBuffer(Buf%) "win32"
Global xUnlockBuffer(Buf%) "win32"

' DDS
Global xCreateDSS(width%,Height%) "win32"
Global xDeleteDSS() "win32"


' Effect Shader
Global xLoadFXFile%(path:Byte Ptr) "win32"
Global xFreeEffect(effect%) "win32"
Global xSetEffectInt(entity%,Name:Byte Ptr,Value%) "win32"
Global xSetEffectBool(entity%,Name:Byte Ptr,Value%) "win32"
Global xSetEffectFloat(entity%,Name:Byte Ptr,Value#) "win32"
Global xSetEffectVector_(entity%,Name:Byte Ptr,x#,y#,z#,w#) "win32"
Global xSetEffectMatrix(entity%,Name:Byte Ptr,f11#,f12#,f13#,f14#,f21#,f22#,f23#,f24#,f31#,f32#,f33#,f34#,f41#,f42#,f43#,f44#) "win32"
Global xSetEffectMatrixSemantic(entity%,Name:Byte Ptr,Value%) "win32"
Global xSetAdditionalMatrix(cam%,index%,mType%) "win32"
Global xSetEffectTexture_(entity%,Name:Byte Ptr,tex%,Frame%) "win32"
Global xDeleteEffectConstant(entity%,Name:Byte Ptr) "win32"
Global xClearEffectConstants(entity%) "win32"
Global xValidateEffectTechnique%(effect%,Name:Byte Ptr) "win32"
Global xSetEffectTechnique(entity%,Name:Byte Ptr) "win32"
Global xSetEntityEffect(entity%,effect%) "win32"
Global xSetEffectEntityTexture_(ent%, name:Byte Ptr, index%) "win32"
'	Effect Matrices
Global xSetEntityMatrix(entity%,mat%) "win32"
Global xSetEntityQuaternion(entity%,quat%) "win32"
Global xGetEntityMatrix%(entity%) "win32"
Global xGetProjectionMatrix(cam%) "win32"
Global xGetViewMatrix(cam%) "win32"
'	Effect Matrix Array
Global xCreateBufferMatrix%(num%) "win32"
Global xBufferMatrixSetElement(buff%,num%,mat%) "win32"
Global xSetEntityMatrixElement#(entity%,r%,c%,Value#) "win32"
Global xBufferMatrixGetElement%(buff%,num%) "win32"
Global xGetEntityMatrixElement#(entity%,r%,c%) "win32"
Global xSetEffectEntityMatrix(entity%,Name:Byte Ptr,mat%) "win32"
Global xSetEffectMatrixArray(entity%,Name:Byte Ptr,bmat%,num%) "win32"
'	Effect Vector Array
Global xBufferVectorsSetElement(buff%,num%,x#,y#,z#,w#) "win32"
Global xBufferVectorsGetElement#(buff%,num%,Pos%) "win32"
Global xCreateBufferVectors%(num%) "win32"
Global xBufferDelete(buff%) "win32"
Global xSetEffectVectorArray(entity%,Name:Byte Ptr,vec%,num%) "win32"
Global xSetEffectFloatArray(entity%,Name:Byte Ptr,val%,num%) "win32"
Global xSetEffectIntArray(entity%,Name:Byte Ptr,val%,num%) "win32"


' PSSM (Shadows)
Global xPSSMRender(cam%,SplitLambda#,num%,tex) "win32"
Global xPSSMInit(cam%,path:Byte Ptr,MapSize%) "win32"
Global xPSSMSetEntity(ent%,caster%,receiver%) "win32"
Global xPSSMLightZoom(zoom#) "win32"
Global xPSSMLightRange(lnear#,lfar#) "win32"
Global xPSSMLightSource(x#,y#,z#) "win32"
Global xPSSMLightTarget(x#,y#,z#) "win32"
Global xPSSMDebugHud(mode%) "win32"


' Sprite
Global xLoadSprite_%(path:Byte Ptr,flags%,parent%) "win32"
Global xCreateSprite%(parent%) "win32"
Global xRotateSprite(entity%,angle#) "win32"
Global xScaleSprite(entity%,xs#,ys#) "win32"
Global xHandleSprite(entity%,x#,y#) "win32"
Global xSpriteViewMode(entity%,mode%) "win32"


' Pick
Global xLinePick_%(x#,y#,z#,dx#,dy#,dz#,dist#) "win32"
Global xPickedX#() "win32"
Global xPickedY#() "win32"
Global xPickedZ#() "win32"
Global xPickedNX#() "win32"
Global xPickedNY#() "win32"
Global xPickedNZ#() "win32"
Global xPickedEntity%() "win32"
Global xPickedSurface%() "win32"
Global xPickedTriangle%() "win32"
Global xPickedTime%() "win32"


' Clip Plane
Global xCameraClipPlane(CAMERA%,index%,enabled%,a#,b#,c#,d#) "win32"
Global xMaxClipPlanes%() "win32"


' Math
Global xAlignToVector_(entity%,x#,y#,z#,a%,f#) "win32"
Global xVectorPitch#(x#,y#,z#) "win32"
Global xVectorYaw#(x#,y#,z#) "win32"
Global xGetMatElement#(entity%,r%,c%) "win32"


' TForm
Global xTFormedX#() "win32"
Global xTFormedY#() "win32"
Global xTFormedZ#() "win32"
Global xTFormPoint(x#,y#,z#,src%,dest%) "win32"
Global xTFormVector(x#,y#,z#,src%,dest%) "win32"
Global xTFormNormal(x#,y#,z#,src%,dest%) "win32"


' Sound
Global xCreateSoundManager() "win32"
Global xCreateListener_%(parent%,rolloffFactor#,dopplerScale#,distanceScale#) "win32"
Global xLoadSound%(path:Byte Ptr) "win32"
Global xLoad3DSound%(path:Byte Ptr) "win32"
Global xEmitSound%(sound%,entity%) "win32"
Global xFreeSound(sound%) "win32"
Global xLoopSound(sound%) "win32"
Global xSoundPitch(sound%,hertz%) "win32"
Global xSoundVolume(sound%,volume#) "win32"
Global xSoundPan(sound%,pan#) "win32"
Global xPlaySound%(sound%) "win32"
Global xPlayMusic%(path:Byte Ptr) "win32"
Global xStopChannel(channel%) "win32"
Global xPauseChannel(channel%) "win32"
Global xResumeChannel(channel%) "win32"
Global xChannelPitch(channel%,hertz%) "win32"
Global xChannelPan(channel%,pan#) "win32"
Global xChannelVolume(channel%,volume#) "win32"
Global xChannelPlaying%(channel%) "win32"


Global lib% = LoadLibraryA(gXorsLibName)

If lib%
	xTextureFilter_ = GetProcAddress(lib,"_xTextureFilter@8")
	xClearTextureFilters = GetProcAddress(lib,"_xClearTextureFilters@0")
	xSurfaceBonesArrayName_ = GetProcAddress(lib,"_xSurfaceBonesArrayName@8")
	xSetSurfaceEffect = GetProcAddress(lib,"_xSetSurfaceEffect@8")
	xSurfaceTechnique_ = GetProcAddress(lib,"_xSurfaceTechnique@8")
	xSurfaceEffectVectorArray_ = GetProcAddress(lib,"_xSurfaceEffectVectorArray@16")
	xSurfaceEffectTexture_ = GetProcAddress(lib,"_xSurfaceEffectTexture@16")
	xSurfaceEffectVector_ = GetProcAddress(lib,"_xSurfaceEffectVector@24")
	xSurfaceEffectEntityTexture_ = GetProcAddress(lib,"_xSurfaceEffectEntityTexture@12")
	xSurfaceEffectInt_ = GetProcAddress(lib,"_xSurfaceEffectInt@12")
	xSurfaceEffectBool_ = GetProcAddress(lib,"_xSurfaceEffectBool@12")
	xSurfaceEffectFloat_ = GetProcAddress(lib,"_xSurfaceEffectFloat@12")
	xSurfaceEffectIntArray_ = GetProcAddress(lib,"_xSurfaceEffectIntArray@16")
	xSurfaceEffectFloatArray_ = GetProcAddress(lib,"_xSurfaceEffectFloatArray@16")
	xSurfaceEffectMatrixArray_ = GetProcAddress(lib,"_xSurfaceEffectMatrixArray@16")
	xSurfaceEffectEntityMatrix_ = GetProcAddress(lib,"_xSurfaceEffectEntityMatrix@12")
	xSurfaceEffectMatrixSemantic_ = GetProcAddress(lib,"_xSurfaceEffectMatrixSemantic@12")
	xDeleteSurfaceConstant_ = GetProcAddress(lib,"_xDeleteSurfaceConstant@8")
	xClearSurfaceConstants = GetProcAddress(lib,"_xClearSurfaceConstants@4")
	xInitDeferred_ = GetProcAddress(lib,"_xInitDeferred@16")
	xSetDeferredShaders_ = GetProcAddress(lib,"_xSetDeferredShaders@8")
	xRenderWorldDeferred_ = GetProcAddress(lib,"_xRenderWorldDeferred@4")
	xRenderShadows = GetProcAddress(lib,"_xRenderShadows@8")
	xLightShadowEpsilons_ = GetProcAddress(lib,"_xLightShadowEpsilons@12")
	xSetShadowShader_ = GetProcAddress(lib,"_xSetShadowShader@4")
	xInitShadows_ = GetProcAddress(lib,"_xInitShadows@12")
	xSetShadowParams_ = GetProcAddress(lib,"_xSetShadowParams@16")
	xEntityCastShadows = GetProcAddress(lib,"_xEntityCastShadows@12")
	xEntityIsCaster = GetProcAddress(lib,"_xEntityIsCaster@8")
	xShadowPriority = GetProcAddress(lib,"_xShadowPriority@4")
	xLightEnableShadows = GetProcAddress(lib,"_xLightEnableShadows@8")
	xLightShadowsEnabled = GetProcAddress(lib,"_xLightShadowsEnabled@4")
	xDIPCounter = GetProcAddress(lib,"_xDIPCounter@0")
	xSurfRendered = GetProcAddress(lib,"_xSurfRendered@0")
	xEntityRendered = GetProcAddress(lib,"_xEntityRendered@0")
	xEntityVisible = GetProcAddress(lib,"_xEntityVisible@4")
	xSetParticleSize = GetProcAddress(lib,"_xSetParticleSize@12")
	xParticleSize = GetProcAddress(lib,"_xParticleSize@8")
	xSetEffectEntityTexture_ = GetProcAddress(lib,"_xSetEffectEntityTexture@12")
	xWaitKey = GetProcAddress(lib,"_xWaitKey@0")
	xVideoInfo_ = GetProcAddress(lib,"_xVideoInfo@0")
	xLoadMeshInThread_ = GetProcAddress(lib,"_xLoadMeshInThread@8")
	xLoadMeshWithChild_ = GetProcAddress(lib,"_xLoadMeshWithChild@8")
	xLoadMeshAsync_ = GetProcAddress(lib,"_xLoadMeshAsync@8")
	xKeyUp = GetProcAddress(lib,"_xKeyUp@4")
	xLine3d = GetProcAddress(lib,"_xLine3d@44")
	xGetSurfaceTexture = GetProcAddress(lib,"_xGetSurfaceTexture@8")
	xGetRenderWindow = GetProcAddress(lib,"_xGetRenderWindow@0")
	xGetAlphaFunc = GetProcAddress(lib,"_xGetAlphaFunc@4")
	xGetAlphaRef = GetProcAddress(lib,"_xGetAlphaRef@4")
'	xGetAlphaSort = GetProcAddress(lib,"_xGetAlphaSort@4")
'	xSetAlphaSort = GetProcAddress(lib,"_xSetAlphaSort@8")
	xSphereInFrustum = GetProcAddress(lib,"_xSphereInFrustum@20")
	xEntityEmissiveColor = GetProcAddress(lib,"_xEntityEmissiveColor@16")
	xDrawBBox = GetProcAddress(lib,"_xDrawBBox@24")
	xLoadTextureInThread_ = GetProcAddress(lib,"_xLoadTextureInThread@8")
	xTextureLoaded = GetProcAddress(lib,"_xTextureLoaded@4")
	xCreateThread = GetProcAddress(lib,"_xCreateThread@4")
	xGetNumberRT = GetProcAddress(lib,"_xGetNumberRT@0")
	xSetMRT = GetProcAddress(lib,"_xSetMRT@12")
	xUnSetMRT = GetProcAddress(lib,"_xUnSetMRT@0")
	xLoadTextureInRAM_ = GetProcAddress(lib,"_xLoadTextureInRAM@4")
	xCreateTextureFromRAM = GetProcAddress(lib,"_xCreateTextureFromRAM@4")
	xGetFunctionAddress_ = GetProcAddress(lib,"_xGetFunctionAddress@4")
	xJoyType_		= GetProcAddress(lib,"_xJoyType@4")
	xJoyDown_		= GetProcAddress(lib,"_xJoyDown@8")
	xJoyHit_		= GetProcAddress(lib,"_xJoyHit@8")
	xGetJoy_	= GetProcAddress(lib,"_xGetJoy@4")
	xWaitJoy_		= GetProcAddress(lib,"_xWaitJoy@4")
	xJoyX_		= GetProcAddress(lib,"_xJoyX@4")
	xJoyY_		= GetProcAddress(lib,"_xJoyY@4")
	xJoyZ_		= GetProcAddress(lib,"_xJoyZ@4")
	xJoyU_		= GetProcAddress(lib,"_xJoyU@4")
	xJoyV_		= GetProcAddress(lib,"_xJoyV@4")
	xJoyPitch_		= GetProcAddress(lib,"_xJoyPitch@4")
	xJoyYaw_		= GetProcAddress(lib,"_xJoyYaw@4")
	xJoyRoll_		= GetProcAddress(lib,"_xJoyRoll@4")
	xJoyHat_		= GetProcAddress(lib,"_xJoyHat@4")
	xJoyXDir_		= GetProcAddress(lib,"_xJoyXDir@4")
	xJoyYDir_		= GetProcAddress(lib,"_xJoyYDir@4")
	xJoyZDir_		= GetProcAddress(lib,"_xJoyZDir@4")
	xJoyUDir_		= GetProcAddress(lib,"_xJoyUDir@4")
	xJoyVDir_		= GetProcAddress(lib,"_xJoyVDir@4")
	xFlushJoy		= GetProcAddress(lib,"_xFlushJoy@0")
	xCollisionTriangle = GetProcAddress(lib,"_xCollisionTriangle@8")
	xGetTotalPageMem		= GetProcAddress(lib,"_xGetTotalPageMem@0")
	xGetTotalPhysMem		= GetProcAddress(lib,"_xGetTotalPhysMem@0")
	xGetTotalVidLocalMem	= GetProcAddress(lib,"_xGetTotalVidLocalMem@0")
	xGetTotalVidMem			=GetProcAddress(lib,"_xGetTotalVidMem@0")
	xGetTotalVidNonlocalMem	= GetProcAddress(lib,"_xGetTotalVidNonlocalMem@0")
	xGetAvailPageMem 		= GetProcAddress(lib,"_xGetAvailPageMem@0")
	xGetAvailPhysMem 		= GetProcAddress(lib,"_xGetAvailPhysMem@0")
	xGetAvailVidLocalMem 	= GetProcAddress(lib,"_xGetAvailVidLocalMem@0")
	xGetAvailVidMem 		= GetProcAddress(lib,"_xGetAvailVidMem@0")
	xGetAvailVidNonlocalMem = GetProcAddress(lib,"_xGetAvailVidNonlocalMem@0")
	xCreate3DLine 	= GetProcAddress(lib,"_xCreate3DLine@4")
	x3DLinePoints	= GetProcAddress(lib,"_x3DLinePoints@28")
	xCPUFamily 		= GetProcAddress(lib,"_xCPUFamily@0")
	xCPUModel		= GetProcAddress(lib,"_xCPUModel@0")
	xCPUName_ 		= GetProcAddress(lib,"_xCPUName@0")
	xCPUSpeed 		= GetProcAddress(lib,"_xCPUSpeed@0")
	xCPUStepping 	= GetProcAddress(lib,"_xCPUStepping@0")
	xCPUVendor_ 		= GetProcAddress(lib,"_xCPUVendor@0")
	xCreateGroup 		= GetProcAddress(lib,"_xCreateGroup@0")
	xGroupAddEntity 	= GetProcAddress(lib,"_xGroupAddEntity@8")
	xRenderGroup 		= GetProcAddress(lib,"_xRenderGroup@4")
	xGroupRemoveEntity 	= GetProcAddress(lib,"_xGroupRemoveEntity@8")
	xSetFrustrumSphere 	= GetProcAddress(lib,"_xSetFrustrumSphere@20")
	xSetEntityQuaternion = GetProcAddress(lib,"_xSetEntityQuaternion@8")
	xSetEntityMatrix = GetProcAddress(lib,"_xSetEntityMatrix@8")
	xReleaseXors = GetProcAddress(lib,"_xReleaseXors@0")
	xGetProjectionMatrix = GetProcAddress(lib,"_xGetProjectionMatrix@4")
	xGetViewMatrix = GetProcAddress(lib,"_xGetViewMatrix@4")
	xEntityClass_ = GetProcAddress(lib,"_xEntityClass@4")
	xDeleteDSS = GetProcAddress(lib,"_xDeleteDSS@0")
	xCreateDSS = GetProcAddress(lib,"_xCreateDSS@8")
	xShowPointer = GetProcAddress(lib,"_xShowPointer@0")
	xHidePointer = GetProcAddress(lib,"_xHidePointer@0")
	xPSSMRender = GetProcAddress(lib,"_xPSSMRender@16")
	xPSSMInit = GetProcAddress(lib,"_xPSSMInit@12")
	xPSSMSetEntity = GetProcAddress(lib,"_xPSSMSetEntity@12")
	xPSSMLightSource = GetProcAddress(lib,"_xPSSMLightSource@12")
	xPSSMLightTarget = GetProcAddress(lib,"_xPSSMLightTarget@12")
	xPSSMDebugHud = GetProcAddress(lib,"_xPSSMDebugHud@4")
	xPSSMLightRange = GetProcAddress(lib,"_xPSSMLightRange@8")
	xPSSMLightZoom = GetProcAddress(lib,"_xPSSMLightZoom@4")
	xSetAlphaRef = GetProcAddress(lib,"_xSetAlphaRef@8")
	xSetAlphaFunc = GetProcAddress(lib,"_xSetAlphaFunc@8")
	xWinMessage = GetProcAddress(lib,"_xWinMessage@4") 
	xGraphics3D_ = GetProcAddress(lib,"_xGraphics3D@20") 
	xGraphicsWidth = GetProcAddress(lib,"_xGraphicsWidth@0") 
	xGraphicsHeight = GetProcAddress(lib,"_xGraphicsHeight@0") 
	xGraphicsDepth = GetProcAddress(lib,"_xGraphicsDepth@0") 
	xLoadDXmesh_ = GetProcAddress(lib,"_xLoadDXmesh@12") 
	xMouseDown = GetProcAddress(lib,"_xMouseDown@4") 
	xMouseX = GetProcAddress(lib,"_xMouseX@0") 
	xMouseY = GetProcAddress(lib,"_xMouseY@0") 
	xMouseZ = GetProcAddress(lib,"_xMouseZ@0") 
	xMouseXSpeed = GetProcAddress(lib,"_xMouseXSpeed@0") 
	xMouseYSpeed = GetProcAddress(lib,"_xMouseYSpeed@0") 
	xMouseZSpeed = GetProcAddress(lib,"_xMouseZSpeed@0") 
	xMoveMouse = GetProcAddress(lib,"_xMoveMouse@8") 
	xMouseHit = GetProcAddress(lib,"_xMouseHit@4") 
	xLoadAnimMesh_ = GetProcAddress(lib,"_xLoadAnimMesh@8") 
	xPositionEntity_ = GetProcAddress(lib,"_xPositionEntity@20") 
	xMoveEntity_ = GetProcAddress(lib,"_xMoveEntity@20") 
	xScaleEntity_ = GetProcAddress(lib,"_xScaleEntity@20") 
	xEntityScaleX= GetProcAddress(lib,"_xEntityScaleX@4") 
	xEntityScaleY= GetProcAddress(lib,"_xEntityScaleY@4") 
	xEntityScaleZ= GetProcAddress(lib,"_xEntityScaleZ@4") 
	xRotateEntity_ = GetProcAddress(lib,"_xRotateEntity@20") 
	xTurnEntity_ = GetProcAddress(lib,"_xTurnEntity@20") 
	xLoadMesh_ = GetProcAddress(lib,"_xLoadMesh@8") 
	xEntityParent_ = GetProcAddress(lib,"_xEntityParent@12") 
	xCopyEntity_ = GetProcAddress(lib,"_xCopyEntity@12") 
	xEntityPickMode_ = GetProcAddress(lib,"_xEntityPickMode@12") 
	xTranslateEntity_ = GetProcAddress(lib,"_xTranslateEntity@20") 
	xPointEntity_ = GetProcAddress(lib,"_xPointEntity@12") 
	xShowEntity = GetProcAddress(lib,"_xShowEntity@4") 
 	xHideEntity = GetProcAddress(lib,"_xHideEntity@4") 
	xNameEntity = GetProcAddress(lib,"_xNameEntity@8") 
	xEntityAlpha = GetProcAddress(lib,"_xEntityAlpha@8") 
	xEntityColor = GetProcAddress(lib,"_xEntityColor@16") 
	xEntityBlend = GetProcAddress(lib,"_xEntityBlend@8") 
	xEntityFX = GetProcAddress(lib,"_xEntityFX@8") 
	xFreeEntity = GetProcAddress(lib,"_xFreeEntity@4") 
	xEntityOrder = GetProcAddress(lib,"_xEntityOrder@8") 
	xEntityDistance = GetProcAddress(lib,"_xEntityDistance@8") 
	xEntitySpecularColor = GetProcAddress(lib,"_xEntitySpecularColor@16") 
	xEntityAutoFade = GetProcAddress(lib,"_xEntityAutoFade@12") 
	xEntityShininess = GetProcAddress(lib,"_xEntityShininess@8") 
	xEntityX_ = GetProcAddress(lib,"_xEntityX@8") 
	xEntityY_ = GetProcAddress(lib,"_xEntityY@8") 
	xEntityZ_ = GetProcAddress(lib,"_xEntityZ@8") 
	xEntityRoll_ = GetProcAddress(lib,"_xEntityRoll@8") 
	xEntityYaw_ = GetProcAddress(lib,"_xEntityYaw@8") 
	xEntityPitch_ = GetProcAddress(lib,"_xEntityPitch@8") 
	xEntityName_ = GetProcAddress(lib,"_xEntityName@4") 
	xGetParent = GetProcAddress(lib,"_xGetParent@4") 
	xCountChildren = GetProcAddress(lib,"_xCountChildren@4") 
	xGetChild = GetProcAddress(lib,"_xGetChild@8") 
	xFindChild = GetProcAddress(lib,"_xFindChild@8") 
	xEntityInView = GetProcAddress(lib,"_xEntityInView@8") 
	xEntityPick = GetProcAddress(lib,"_xEntityPick@8") 
	xCreateCamera_ = GetProcAddress(lib,"_xCreateCamera@4") 
	xCameraFogMode = GetProcAddress(lib,"_xCameraFogMode@8") 
	xCameraFogRange = GetProcAddress(lib,"_xCameraFogRange@12") 
	xCameraFogColor = GetProcAddress(lib,"_xCameraFogColor@16") 
	xCameraClsColor = GetProcAddress(lib,"_xCameraClsColor@16") 
	xCameraClsMode = GetProcAddress(lib,"_xCameraClsMode@12") 
	xCameraViewport = GetProcAddress(lib,"_xCameraViewport@20") 
	xCameraProjMode = GetProcAddress(lib,"_xCameraProjMode@8") 
	xCameraRange = GetProcAddress(lib,"_xCameraRange@12") 
	xCameraProject = GetProcAddress(lib,"_xCameraProject@16") 
	xCameraPick = GetProcAddress(lib,"_xCameraPick@12") 
	xCameraZoom = GetProcAddress(lib,"_xCameraZoom@8") 
	xDrawImage_ = GetProcAddress(lib,"_xDrawImage@16") 
	xDrawImageRect_ = GetProcAddress(lib,"_xDrawImageRect@32") 
	xSaveImage_ = GetProcAddress(lib,"_xSaveImage@12") 
	xTileImage_ = GetProcAddress(lib,"_xTileImage@16") 
	xLoadImage = GetProcAddress(lib,"_xLoadImage@4") 
	xLoadAnimImage = GetProcAddress(lib,"_xLoadAnimImage@20") 
	xScaleImage = GetProcAddress(lib,"_xScaleImage@12") 
	xRotateImage = GetProcAddress(lib,"_xRotateImage@8") 
	xImageWidth = GetProcAddress(lib,"_xImageWidth@4") 
	xImageHeight = GetProcAddress(lib,"_xImageHeight@4") 
	xImagesCollide = GetProcAddress(lib,"_xImagesCollide@32") 
	xImagesOverlap = GetProcAddress(lib,"_xImagesOverlap@24") 
	xImageRectCollide = GetProcAddress(lib,"_xImageRectCollide@32") 
	xImageRectOverlap = GetProcAddress(lib,"_xImageRectOverlap@28") 
	xImageXHandle = GetProcAddress(lib,"_xImageXHandle@4") 
	xImageYHandle = GetProcAddress(lib,"_xImageYHandle@4") 
	xHandleImage = GetProcAddress(lib,"_xHandleImage@12") 
	xMidHandle = GetProcAddress(lib,"_xMidHandle@4") 
	xAutoMidHandle = GetProcAddress(lib,"_xAutoMidHandle@4") 
	xFreeImage = GetProcAddress(lib,"_xFreeImage@4") 
	xCreateImage_ = GetProcAddress(lib,"_xCreateImage@12") 
	xWritePixel_ = GetProcAddress(lib,"_xWritePixel@16") 
	xWritePixelFast_ = GetProcAddress(lib,"_xWritePixelFast@16") 
	xReadPixel_ = GetProcAddress(lib,"_xReadPixel@12") 
	xReadPixelFast_ = GetProcAddress(lib,"_xReadPixelFast@12") 
	xCopyPixel_ = GetProcAddress(lib,"_xCopyPixel@24") 
	xCopyPixelFast_ = GetProcAddress(lib,"_xCopyPixelFast@24") 
	xColorRed = GetProcAddress(lib,"_xColorRed@0") 
	xColorBlue = GetProcAddress(lib,"_xColorBlue@0") 
	xColorGreen = GetProcAddress(lib,"_xColorGreen@0") 
	xCopyRect = GetProcAddress(lib,"_xCopyRect@32")
	xStretchRect = GetProcAddress(lib,"_xStretchRect@44")
	xStretchBackBuffer = GetProcAddress(lib,"_xStretchBackBuffer@24")
	xGetColor = GetProcAddress(lib,"_xGetColor@8") 
	xCollisions = GetProcAddress(lib,"_xCollisions@16") 
	xEntityType = GetProcAddress(lib,"_xEntityType@12") 
	xEntityRadius = GetProcAddress(lib,"_xEntityRadius@8") 
	xGetEntityType = GetProcAddress(lib,"_xGetEntityType@4") 
	xCountCollisions = GetProcAddress(lib,"_xCountCollisions@4") 
	xCollisionX = GetProcAddress(lib,"_xCollisionX@8") 
	xCollisionY = GetProcAddress(lib,"_xCollisionY@8") 
	xCollisionZ = GetProcAddress(lib,"_xCollisionZ@8") 
	xCollisionNX = GetProcAddress(lib,"_xCollisionNX@8") 
	xCollisionNY = GetProcAddress(lib,"_xCollisionNY@8") 
	xCollisionNZ = GetProcAddress(lib,"_xCollisionNZ@8") 
	xCollisionTime = GetProcAddress(lib,"_xCollisionTime@8") 
	xCollisionEntity = GetProcAddress(lib,"_xCollisionEntity@8") 
	xCollisionSurface = GetProcAddress(lib,"_xCollisionSurface@8") 
	xEntityBox = GetProcAddress(lib,"_xEntityBox@28") 
	xCreateParticleSystem_ = GetProcAddress(lib,"_xCreateParticleSystem@20") 
	xParticleSystemTexture_ = GetProcAddress(lib,"_xParticleSystemTexture@12") 
	xCreateParticle_ = GetProcAddress(lib,"_xCreateParticle@8") 
	xPositionParticle = GetProcAddress(lib,"_xPositionParticle@20") 
	xMoveParticle = GetProcAddress(lib,"_xMoveParticle@20") 
	xParticleX = GetProcAddress(lib,"_xParticleX@8") 
	xParticleY = GetProcAddress(lib,"_xParticleY@8") 
	xParticleZ = GetProcAddress(lib,"_xParticleZ@8") 
	xParticleDX = GetProcAddress(lib,"_xParticleDX@8") 
	xParticleDY = GetProcAddress(lib,"_xParticleDY@8") 
	xParticleDZ = GetProcAddress(lib,"_xParticleDZ@8") 
	xParticleDirection = GetProcAddress(lib,"_xParticleDirection@20") 
	xSetParticleAge = GetProcAddress(lib,"_xSetParticleAge@12") 
	xParticleAge = GetProcAddress(lib,"_xParticleAge@8") 
	xSetParticleAcceleration = GetProcAddress(lib,"_xSetParticleAcceleration@12") 
	xParticleAcceleration = GetProcAddress(lib,"_xParticleAcceleration@8") 
	xSetParticleVelocity = GetProcAddress(lib,"_xSetParticleVelocity@12") 
	xParticleVelocity = GetProcAddress(lib,"_xParticleVelocity@8") 
	xParticlesCounter = GetProcAddress(lib,"_xParticlesCounter@4") 
	xParticleColor = GetProcAddress(lib,"_xParticleColor@20") 
	xParticleRed = GetProcAddress(lib,"_xParticleRed@8") 
	xParticleGreen = GetProcAddress(lib,"_xParticleGreen@8") 
	xParticleBlue = GetProcAddress(lib,"_xParticleBlue@8") 
	xFreeParticle = GetProcAddress(lib,"_xFreeParticle@8") 
	xAddVertex_ = GetProcAddress(lib,"_xAddVertex@28") 
	xCreateSurface_ = GetProcAddress(lib,"_xCreateSurface@8") 
	xVertexTexCoords_ = GetProcAddress(lib,"_xVertexTexCoords@24")
	xEnableEntityShader = GetProcAddress(lib,"_xEnableEntityShader@8")
	xEntityAmbientColor = GetProcAddress(lib,"_xEntityAmbientColor@12")
	xVertexU_ = GetProcAddress(lib,"_xVertexU@12") 
	xVertexV_ = GetProcAddress(lib,"_xVertexV@12") 
	xVertexW_ = GetProcAddress(lib,"_xVertexW@12") 
	xClearSurface_ = GetProcAddress(lib,"_xClearSurface@12") 
	xAddTriangle = GetProcAddress(lib,"_xAddTriangle@16") 
	xVertexCoords = GetProcAddress(lib,"_xVertexCoords@20") 
	xVertexNormal = GetProcAddress(lib,"_xVertexNormal@20") 
	xVertexColor = GetProcAddress(lib,"_xVertexColor@24") 
	xCountVertices = GetProcAddress(lib,"_xCountVertices@4") 
	xCountTriangles = GetProcAddress(lib,"_xCountTriangles@4") 
	xVertexX = GetProcAddress(lib,"_xVertexX@8") 
	xVertexY = GetProcAddress(lib,"_xVertexY@8") 
	xVertexZ = GetProcAddress(lib,"_xVertexZ@8") 
	xVertexNX = GetProcAddress(lib,"_xVertexNX@8") 
	xVertexNY = GetProcAddress(lib,"_xVertexNY@8") 
	xVertexNZ = GetProcAddress(lib,"_xVertexNZ@8") 
	xVertexRed = GetProcAddress(lib,"_xVertexRed@8") 
	xVertexGreen = GetProcAddress(lib,"_xVertexGreen@8") 
	xVertexBlue = GetProcAddress(lib,"_xVertexBlue@8") 
	xVertexAlpha = GetProcAddress(lib,"_xVertexAlpha@8") 
	xTriangleVertex = GetProcAddress(lib,"_xTriangleVertex@12") 
	xPaintSurface = GetProcAddress(lib,"_xPaintSurface@8") 
	xFindSurface = GetProcAddress(lib,"_xFindSurface@8") 
	xCountSurfaces = GetProcAddress(lib,"_xCountSurfaces@4") 
	xGetSurface = GetProcAddress(lib,"_xGetSurface@8") 
	xUpdateNormals = GetProcAddress(lib,"_xUpdateNormals@4") 
	xGetSurfaceBrush = GetProcAddress(lib,"_xGetSurfaceBrush@4") 
	xLoadTexture_ = GetProcAddress(lib,"_xLoadTexture@8") 
	xCreateTexture_ = GetProcAddress(lib,"_xCreateTexture@16") 
	xEntityTexture_ = GetProcAddress(lib,"_xEntityTexture@16") 
	xTextureWidth = GetProcAddress(lib,"_xTextureWidth@4") 
	xTextureHeight = GetProcAddress(lib,"_xTextureHeight@4") 
	xTextureBlend = GetProcAddress(lib,"_xTextureBlend@8") 
	xTextureCoords = GetProcAddress(lib,"_xTextureCoords@8") 
	xLoadAnimTexture = GetProcAddress(lib,"_xLoadAnimTexture@24") 
	xFreeTexture = GetProcAddress(lib,"_xFreeTexture@4") 
	xSetTextureFiltering = GetProcAddress(lib,"_xSetTextureFiltering@4") 
	xPositionTexture = GetProcAddress(lib,"_xPositionTexture@12") 
	xRotateTexture = GetProcAddress(lib,"_xRotateTexture@8") 
	xScaleTexture = GetProcAddress(lib,"_xScaleTexture@12") 
	xTextureName_ = GetProcAddress(lib,"_xTextureName@4") 
	xGetTextureSurface = GetProcAddress(lib,"_xGetTextureSurface@8") 
	xGetTextureFrames = GetProcAddress(lib,"_xGetTextureFrames@4") 
	xCreateCube_ = GetProcAddress(lib,"_xCreateCube@4") 
	xCreateSphere_ = GetProcAddress(lib,"_xCreateSphere@8") 
	xCreateCylinder_ = GetProcAddress(lib,"_xCreateCylinder@12") 
	xCreatePivot_ = GetProcAddress(lib,"_xCreatePivot@4") 
	xCreateCone_ = GetProcAddress(lib,"_xCreateCone@12") 
	xAnimate_ = GetProcAddress(lib,"_xAnimate@24") 
	xExtractAnimSeq_ = GetProcAddress(lib,"_xExtractAnimSeq@16") 
	xAnimating_ = GetProcAddress(lib,"_xAnimating@8") 
	xAnimTime_ = GetProcAddress(lib,"_xAnimTime@8") 
	xAnimSeq_ = GetProcAddress(lib,"_xAnimSeq@8") 
	xAnimLength_ = GetProcAddress(lib,"_xAnimLength@8") 
	xSetAnimTime_ = GetProcAddress(lib,"_xSetAnimTime@12") 
	xAnimSpeed_ = GetProcAddress(lib,"_xAnimSpeed@8") 
	xSetAnimSpeed_ = GetProcAddress(lib,"_xSetAnimSpeed@12") 
	xLoadAnimSeq_ = GetProcAddress(lib,"_xLoadAnimSeq@8") 
	xSetSkinningMethod = GetProcAddress(lib,"_xSetSkinningMethod@4") 
	xCreateLight_ = GetProcAddress(lib,"_xCreateLight@4") 
	xLightRange = GetProcAddress(lib,"_xLightRange@8") 
	xLightColor = GetProcAddress(lib,"_xLightColor@16") 
	xLightConeAngles = GetProcAddress(lib,"_xLightConeAngles@12") 
	xAmbientLight = GetProcAddress(lib,"_xAmbientLight@12") 
	xCreateMesh_ = GetProcAddress(lib,"_xCreateMesh@4") 
	xCopyMesh_ = GetProcAddress(lib,"_xCopyMesh@8") 
	xUpdateMeshVBPositions = GetProcAddress(lib,"_xUpdateMeshVBPositions@8") 
	xUpdateMeshVBNormals = GetProcAddress(lib,"_xUpdateMeshVBNormals@8") 
	xUpdateMeshIB = GetProcAddress(lib,"_xUpdateMeshIB@8") 
	xScaleMesh = GetProcAddress(lib,"_xScaleMesh@16") 
	xRotateMesh = GetProcAddress(lib,"_xRotateMesh@16") 
	xPositionMesh = GetProcAddress(lib,"_xPositionMesh@16") 
	xMeshWidth = GetProcAddress(lib,"_xMeshWidth@4") 
	xMeshHeight = GetProcAddress(lib,"_xMeshHeight@4") 
	xMeshDepth = GetProcAddress(lib,"_xMeshDepth@4") 
	xFlipMesh = GetProcAddress(lib,"_xFlipMesh@4") 
	xAddMesh = GetProcAddress(lib,"_xAddMesh@8") 
	xMeshesIntersect = GetProcAddress(lib,"_xMeshesIntersect@8") 
	xGetMeshVB = GetProcAddress(lib,"_xGetMeshVB@4") 
	xGetMeshIB = GetProcAddress(lib,"_xGetMeshIB@4") 
	xGetMeshVBSize = GetProcAddress(lib,"_xGetMeshVBSize@4") 
	xGetMeshIBSize = GetProcAddress(lib,"_xGetMeshIBSize@4") 
	xDeleteMeshVB = GetProcAddress(lib,"_xDeleteMeshVB@4") 
	xDeleteMeshIB = GetProcAddress(lib,"_xDeleteMeshIB@4") 
	xSetPostEffect_ = GetProcAddress(lib,"_xSetPostEffect@8") 
	xSetPostEffectVector_ = GetProcAddress(lib,"_xSetPostEffectVector@24") 
	xLoadPostEffect = GetProcAddress(lib,"_xLoadPostEffect@12") 
	xSetPostEffectBaseSampler = GetProcAddress(lib,"_xSetPostEffectBaseSampler@8") 
	xFreePostEffect = GetProcAddress(lib,"_xFreePostEffect@4") 
	xSetPostEffectInt = GetProcAddress(lib,"_xSetPostEffectInt@12") 
	xSetPostEffectBool = GetProcAddress(lib,"_xSetPostEffectBool@12") 
	xSetPostEffectFloat = GetProcAddress(lib,"_xSetPostEffectFloat@12") 
	xSetPostEffectDefaults = GetProcAddress(lib,"_xSetPostEffectDefaults@4") 
	xSetPostEffectTexture = GetProcAddress(lib,"_xSetPostEffectTexture@12") 
	xEnablePostProcessing = GetProcAddress(lib,"_xEnablePostProcessing@4") 
	xSetPostEffectSceneSampler = GetProcAddress(lib,"_xSetPostEffectSceneSampler@8") 
	xSetPostEffectBaseSamplerScale = GetProcAddress(lib,"_xSetPostEffectBaseSamplerScale@12") 
	xSetVertexShaderVector_ = GetProcAddress(lib,"_xSetVertexShaderVector@24") 
	xSetPixelShaderVector_ = GetProcAddress(lib,"_xSetPixelShaderVector@24") 
	xSetPixelShaderTexture_ = GetProcAddress(lib,"_xSetPixelShaderTexture@16") 
	xSetPixelShaderEntityTexture_ = GetProcAddress(lib,"_xSetPixelShaderEntityTexture@12") 
	xLoadVertexShader = GetProcAddress(lib,"_xLoadVertexShader@12") 
	xLoadPixelShader = GetProcAddress(lib,"_xLoadPixelShader@12") 
	xSetEntityVertexShader = GetProcAddress(lib,"_xSetEntityVertexShader@8") 
	xSetEntityPixelShader = GetProcAddress(lib,"_xSetEntityPixelShader@8") 
	xSetVertexShaderBool = GetProcAddress(lib,"_xSetVertexShaderBool@12") 
	xSetPixelShaderBool = GetProcAddress(lib,"_xSetPixelShaderBool@12") 
	xSetVertexShaderInt = GetProcAddress(lib,"_xSetVertexShaderInt@12") 
	xSetPixelShaderInt = GetProcAddress(lib,"_xSetPixelShaderInt@12") 
	xSetVertexShaderFloat = GetProcAddress(lib,"_xSetVertexShaderFloat@12") 
	xSetPixelShaderFloat = GetProcAddress(lib,"_xSetPixelShaderFloat@12") 
	xSetVertexShaderMatrix = GetProcAddress(lib,"_xSetVertexShaderMatrix@72") 
	xSetPixelShaderMatrix = GetProcAddress(lib,"_xSetPixelShaderMatrix@72") 
	xSetVertexShaderDefaults = GetProcAddress(lib,"_xSetVertexShaderDefaults@4") 
	xSetPixelShaderDefaults = GetProcAddress(lib,"_xSetPixelShaderDefaults@4") 
	xSetVertexShaderMatrixSemantic = GetProcAddress(lib,"_xSetVertexShaderMatrixSemantic@12") 
	xSetPixelShaderMatrixSemantic = GetProcAddress(lib,"_xSetPixelShaderMatrixSemantic@12") 
	xDeleteVertexShaderConstant = GetProcAddress(lib,"_xDeleteVertexShaderConstant@8") 
	xDeletePixelShaderConstant = GetProcAddress(lib,"_xDeletePixelShaderConstant@8") 
	xClearVertexShaderConstants = GetProcAddress(lib,"_xClearVertexShaderConstants@4") 
	xClearPixelShaderConstants = GetProcAddress(lib,"_xClearPixelShaderConstants@4") 
	xGetMaxPixelShaderVersion = GetProcAddress(lib,"_xGetMaxPixelShaderVersion@0") 
	xGetMaxVertexShaderVersion = GetProcAddress(lib,"_xGetMaxVertexShaderVersion@0") 
	xLoadTerrain_ = GetProcAddress(lib,"_xLoadTerrain@8") 
	xModifyTerrain_ = GetProcAddress(lib,"_xModifyTerrain@20") 
	xCreateTerrain_ = GetProcAddress(lib,"_xCreateTerrain@8") 
	xTerrainShading = GetProcAddress(lib,"_xTerrainShading@8") 
	xTerrainHeight = GetProcAddress(lib,"_xTerrainHeight@12") 
	xTerrainSizeX = GetProcAddress(lib,"_xTerrainSizeX@4") 
	xTerrainSizeZ = GetProcAddress(lib,"_xTerrainSizeZ@4") 
	xTerrainX = GetProcAddress(lib,"_xTerrainX@16") 
	xTerrainY = GetProcAddress(lib,"_xTerrainY@16") 
	xTerrainZ = GetProcAddress(lib,"_xTerrainZ@16") 
	xCreateBrush_ = GetProcAddress(lib,"_xCreateBrush@12") 
	xBrushTexture_ = GetProcAddress(lib,"_xBrushTexture@16") 
	xLoadBrush_ = GetProcAddress(lib,"_xLoadBrush@16") 
	xBrushColor = GetProcAddress(lib,"_xBrushColor@16") 
	xBrushAlpha = GetProcAddress(lib,"_xBrushAlpha@8") 
	xBrushShininess = GetProcAddress(lib,"_xBrushShininess@8") 
	xBrushBlend = GetProcAddress(lib,"_xBrushBlend@8") 
	xBrushFX = GetProcAddress(lib,"_xBrushFX@8") 
	xPaintEntity = GetProcAddress(lib,"_xPaintEntity@8") 
	xGetBrushTexture = GetProcAddress(lib,"_xGetBrushTexture@8") 
	xGetEntityBrush = GetProcAddress(lib,"_xGetEntityBrush@4") 
	xPaintMesh = GetProcAddress(lib,"_xPaintMesh@8") 
	xFreeBrush = GetProcAddress(lib,"_xFreeBrush@4") 
	xImageBuffer_ = GetProcAddress(lib,"_xImageBuffer@8") 
	xTextureBuffer_ = GetProcAddress(lib,"_xTextureBuffer@8") 
	xSaveBuffer = GetProcAddress(lib,"_xSaveBuffer@8") 
	xLoadBuffer = GetProcAddress(lib,"_xLoadBuffer@8") 
	xSetBuffer = GetProcAddress(lib,"_xSetBuffer@4") 
	xGraphicsBuffer = GetProcAddress(lib,"_xGraphicsBuffer@4") 
	xBackBuffer = GetProcAddress(lib,"_xBackBuffer@0") 
	xLockBuffer = GetProcAddress(lib,"_xLockBuffer@4") 
	xUnlockBuffer = GetProcAddress(lib,"_xUnlockBuffer@4") 
	xSetEffectTexture_ = GetProcAddress(lib,"_xSetEffectTexture@16") 
	xSetEffectVector_ = GetProcAddress(lib,"_xSetEffectVector@24") 
	xLoadFXFile = GetProcAddress(lib,"_xLoadFXFile@4") 
	xFreeEffect = GetProcAddress(lib,"_xFreeEffect@4") 
	xSetEntityEffect = GetProcAddress(lib,"_xSetEntityEffect@8") 
	xSetEffectInt = GetProcAddress(lib,"_xSetEffectInt@12") 
	xSetEffectBool = GetProcAddress(lib,"_xSetEffectBool@12") 
	xSetEffectFloat = GetProcAddress(lib,"_xSetEffectFloat@12") 
	xSetEffectMatrix = GetProcAddress(lib,"_xSetEffectMatrix@72") 
	xSetEffectMatrixSemantic = GetProcAddress(lib,"_xSetEffectMatrixSemantic@12") 
	xDeleteEffectConstant = GetProcAddress(lib,"_xDeleteEffectConstant@8") 
	xClearEffectConstants = GetProcAddress(lib,"_xClearEffectConstants@4") 
	xValidateEffectTechnique = GetProcAddress(lib,"_xValidateEffectTechnique@8") 
	xSetEffectTechnique = GetProcAddress(lib,"_xSetEffectTechnique@8") 
	xLoadSprite_ = GetProcAddress(lib,"_xLoadSprite@12") 
	xCreateSprite = GetProcAddress(lib,"_xCreateSprite@4") 
	xRotateSprite = GetProcAddress(lib,"_xRotateSprite@8") 
	xScaleSprite = GetProcAddress(lib,"_xScaleSprite@12") 
	xHandleSprite = GetProcAddress(lib,"_xHandleSprite@12") 
	xSpriteViewMode = GetProcAddress(lib,"_xSpriteViewMode@8") 
	xLinePick_ = GetProcAddress(lib,"_xLinePick@28") 
	xPickedX = GetProcAddress(lib,"_xPickedX@0") 
	xPickedY = GetProcAddress(lib,"_xPickedY@0") 
	xPickedZ = GetProcAddress(lib,"_xPickedZ@0") 
	xPickedNX = GetProcAddress(lib,"_xPickedNX@0") 
	xPickedNY = GetProcAddress(lib,"_xPickedNY@0") 
	xPickedNZ = GetProcAddress(lib,"_xPickedNZ@0") 
	xPickedEntity = GetProcAddress(lib,"_xPickedEntity@0") 
	xPickedSurface = GetProcAddress(lib,"_xPickedSurface@0") 
	xPickedTriangle = GetProcAddress(lib,"_xPickedTriangle@0") 
	xPickedTime = GetProcAddress(lib,"_xPickedTime@0") 
	xAlignToVector_ = GetProcAddress(lib,"_xAlignToVector@24") 
	xVectorPitch = GetProcAddress(lib,"_xVectorPitch@12") 
	xVectorYaw = GetProcAddress(lib,"_xVectorYaw@12") 
	xDeltaPitch = GetProcAddress(lib,"_xDeltaPitch@8") 
	xDeltaYaw = GetProcAddress(lib,"_xDeltaYaw@8") 
	xTFormedX = GetProcAddress(lib,"_xTFormedX@0") 
	xTFormedY = GetProcAddress(lib,"_xTFormedY@0") 
	xTFormedZ = GetProcAddress(lib,"_xTFormedZ@0") 
	xTFormPoint = GetProcAddress(lib,"_xTFormPoint@20") 
	xTFormVector = GetProcAddress(lib,"_xTFormVector@20") 
	xTFormNormal = GetProcAddress(lib,"_xTFormNormal@20") 
	xCreateListener_ = GetProcAddress(lib,"_xCreateListener@16") 
	xLoadSound = GetProcAddress(lib,"_xLoadSound@4") 
	xLoad3DSound = GetProcAddress(lib,"_xLoad3DSound@4") 
	xEmitSound = GetProcAddress(lib,"_xEmitSound@8") 
	xFreeSound = GetProcAddress(lib,"_xFreeSound@4") 
	xLoopSound = GetProcAddress(lib,"_xLoopSound@4") 
	xSoundPitch = GetProcAddress(lib,"_xSoundPitch@8") 
	xSoundVolume = GetProcAddress(lib,"_xSoundVolume@8") 
	xSoundPan = GetProcAddress(lib,"_xSoundPan@8") 
	xPlaySound = GetProcAddress(lib,"_xPlaySound@4") 
	xPlayMusic = GetProcAddress(lib,"_xPlayMusic@4") 
	xStopChannel = GetProcAddress(lib,"_xStopChannel@4") 
	xPauseChannel = GetProcAddress(lib,"_xPauseChannel@4") 
	xResumeChannel = GetProcAddress(lib,"_xResumeChannel@4") 
	xChannelPitch = GetProcAddress(lib,"_xChannelPitch@8") 
	xChannelPan = GetProcAddress(lib,"_xChannelPan@8") 
	xChannelVolume = GetProcAddress(lib,"_xChannelVolume@8") 
	xChannelPlaying = GetProcAddress(lib,"_xChannelPlaying@4") 
	xLoadFont_ = GetProcAddress(lib,"_xLoadFont@20") 
	xSetFont = GetProcAddress(lib,"_xSetFont@4") 
	xFontWidth = GetProcAddress(lib,"_xFontWidth@0") 
	xFontHeight = GetProcAddress(lib,"_xFontHeight@0") 
	xFreeFont = GetProcAddress(lib,"_xFreeFont@4") 
	xRenderWorld_ = GetProcAddress(lib,"_xRenderWorld@4") 
	xUpdateWorld_ = GetProcAddress(lib,"_xUpdateWorld@4") 
	xRect_ = GetProcAddress(lib,"_xRect@20") 
	xOval_ = GetProcAddress(lib,"_xOval@20") 
	xText_ = GetProcAddress(lib,"_xText@20") 
	xStringWidth = GetProcAddress(lib,"_xStringWidth@4") 
	xStringHeight = GetProcAddress(lib,"_xStringHeight@4") 
	xLine = GetProcAddress(lib,"_xLine@16") 
	xOrigin = GetProcAddress(lib,"_xOrigin@8") 
	xTrisRendered = GetProcAddress(lib,"_xTrisRendered@0") 
	'xInitialize = GetProcAddress(lib,"_xInitialize@0") 
	xCls = GetProcAddress(lib,"_xCls@0") 
	xFlip = GetProcAddress(lib,"_xFlip@0") 
	xAppTitle_ = GetProcAddress(lib,"_xAppTitle@4") 
	xColor = GetProcAddress(lib,"_xColor@12") 
	xClsColor = GetProcAddress(lib,"_xClsColor@12") 
	xDither = GetProcAddress(lib,"_xDither@4") 
	xClearWorld = GetProcAddress(lib,"_xClearWorld@12") 
	xWireframe = GetProcAddress(lib,"_xWireframe@4") 
	xProjectedX = GetProcAddress(lib,"_xProjectedX@0") 
	xProjectedY = GetProcAddress(lib,"_xProjectedY@0") 
	xProjectedZ = GetProcAddress(lib,"_xProjectedZ@0") 
	xGetMatElement = GetProcAddress(lib,"_xGetMatElement@12") 
	xAntiAlias = GetProcAddress(lib,"_xAntiAlias@4") 
	xSetAntiAliasType = GetProcAddress(lib,"_xSetAntiAliasType@4") 
	xGetMaxAntiAlias = GetProcAddress(lib,"_xGetMaxAntiAlias@0") 
	xSetWND = GetProcAddress(lib,"_xSetWND@4") 
	xSetAdditionalMatrix = GetProcAddress(lib,"_xSetAdditionalMatrix@12") 
	xSetBonesArrayName = GetProcAddress(lib,"_xSetBonesArrayName@8") 
	xSetCubeFace = GetProcAddress(lib,"_xSetCubeFace@8") 
	xKeyHit = GetProcAddress(lib,"_xKeyHit@4") 
	xKeyDown = GetProcAddress(lib,"_xKeyDown@4")
	xGetKey = GetProcAddress(lib,"_xGetKey@0")
	xKey = GetProcAddress(lib,"_xKey@4")
	xGetFPS = GetProcAddress(lib,"_xGetFPS@0")
	xSetRenderWindow = GetProcAddress(lib,"_xSetRenderWindow@4")
	xCameraClipPlane = GetProcAddress(lib,"_xCameraClipPlane@28")
	xMaxClipPlanes = GetProcAddress(lib,"_xMaxClipPlanes@0")
	xGetDevice = GetProcAddress(lib,"_xGetDevice@0")
	xUpdateIM = GetProcAddress(lib,"_xUpdateIM@0")
	
	' Effect Matrices
	xCreateBufferMatrix = GetProcAddress(lib,"_xCreateBufferMatrix@4") 
	xBufferMatrixSetElement = GetProcAddress(lib,"_xBufferMatrixSetElement@12") 
	xSetEntityMatrixElement = GetProcAddress(lib,"_xSetEntityMatrixElement@16") 
	xBufferMatrixGetElement = GetProcAddress(lib,"_xBufferMatrixGetElement@8") 
	xGetEntityMatrixElement = GetProcAddress(lib,"_xGetEntityMatrixElement@12") 
	xSetEffectEntityMatrix = GetProcAddress(lib,"_xSetEffectEntityMatrix@12") 
	xGetEntityMatrix = GetProcAddress(lib,"_xGetEntityMatrix@4") 
	xSetEffectMatrixArray = GetProcAddress(lib,"_xSetEffectMatrixArray@16") 
	
	xBufferVectorsSetElement = GetProcAddress(lib,"_xBufferVectorsSetElement@24") 
	xBufferVectorsGetElement = GetProcAddress(lib,"_xBufferVectorsGetElement@12") 
	xCreateBufferVectors = GetProcAddress(lib,"_xCreateBufferVectors@4") 
	xBufferDelete = GetProcAddress(lib,"_xBufferDelete@4") 
	xSetEffectVectorArray = GetProcAddress(lib,"_xSetEffectVectorArray@16") 
	xSetEffectFloatArray = GetProcAddress(lib,"_xSetEffectFloatArray@16") 
	xSetEffectIntArray = GetProcAddress(lib,"_xSetEffectIntArray@16") 
	
	xMakeSingleSurface = GetProcAddress(lib,"_xMakeSingleSurface@4")  
	xUpdatePhysXPose = GetProcAddress(lib,"_xUpdatePhysxPose@4") 
	
	xGetEntityAlpha = GetProcAddress(lib,"_xGetEntityAlpha@4") 
	xSetMeshVNIB = GetProcAddress(lib,"_xSetMeshVNIB@28") 
	xEntityShader = GetProcAddress(lib,"_xEntityShader@8") 
	xSetNeedUpdateBoundingSphere = GetProcAddress(lib,"_xSetNeedUpdateBoundingSphere@8") 
	
	xCreatePoly = GetProcAddress(lib,"_xCreatePoly@8") 
	xRenderPostEffect = GetProcAddress(lib,"_xRenderPostEffect@4") 
	xCreatePostEffectPoly = GetProcAddress(lib,"_xCreatePostEffectPoly@8") 
	
	xLostDevice = GetProcAddress(lib,"_xLostDevice@0") 
	xCreateSoundManager = GetProcAddress(lib,"_xCreateSoundManager@0") 
	
	xCreateLog_ = GetProcAddress(lib,"_xCreateLog@12")
	xSetLogLevel = GetProcAddress(lib,"_xSetLogLevel@4")
	xSetLogTarget = GetProcAddress(lib,"_xSetLogTarget@4")
	xGetLogLevel = GetProcAddress(lib,"_xGetLogLevel@0")
	xGetLogTarget  = GetProcAddress(lib,"_xGetLogTarget@0")
	xClearLogString  = GetProcAddress(lib,"_xClearLogString@0")
	xGetLogString_  = GetProcAddress(lib,"_xGetLogString@0")
Else
	RuntimeError("Invalid " + gXorsLibName) 
	End
End If

Global xDefaultFont%
Type Vector4D
	Field x# = 0.0,y# = 0.0,z# = 0.0,w# = 1.0
End Type
Type Matrix
	Field e11# = 0.0,e12# = 0.0,e13# = 0.0,e14# = 0.0
	Field e21# = 0.0,e22# = 0.0,e23# = 0.0,e24# = 0.0
	Field e31# = 0.0,e32# = 0.0,e33# = 0.0,e34# = 0.0
	Field e41# = 0.0,e42# = 0.0,e43# = 0.0,e44# = 0.0
End Type

'
Function xTextureFilter(name:String, flags:Int)
	xTextureFilter_(String(name).ToCString(), flags%)
End Function

Function xSurfaceBonesArrayName(surface%, baName:String)
	xSurfaceBonesArrayName_(surface%, String(baName).ToCString())
End Function

Function xSurfaceTechnique(surface%, name:String)
	xSurfaceTechnique_(surface%, String(name).ToCString())
End Function

Function xSurfaceEffectVectorArray(surface%, name:String, value%, size%)
	xSurfaceEffectVectorArray_(surface%, String(name).ToCString(), value%, size%)
End Function

Function xSurfaceEffectTexture(surface%, name:String, texture%, frame% = 0)
	xSurfaceEffectTexture_(surface%, String(name).ToCString(), texture%, frame%)
End Function

Function xSurfaceEffectVector(surface%, name:String, x#, y#, z#, w# = 1.0)
	xSurfaceEffectVector_(surface%, String(name).ToCString(), x#, y#, z#, w#)
End Function

Function xSurfaceEffectEntityTexture(surface%, name:String, index% = 0)
	xSurfaceEffectEntityTexture_(surface%, String(name).ToCString(), index%)
End Function

Function xSurfaceEffectInt(surface%, name:String, value%)
	xSurfaceEffectInt_(surface%, String(name).ToCString(), value%)
End Function

Function xSurfaceEffectBool(surface%, name:String, value%)
	xSurfaceEffectBool_(surface%, String(name).ToCString(), value%)
End Function

Function xSurfaceEffectFloat(surface%, name:String, value#)
	xSurfaceEffectFloat_(surface%, String(name).ToCString(), value#)
End Function

Function xSurfaceEffectIntArray(surface%, name:String, value%, size%)
	xSurfaceEffectIntArray_(surface%, String(name).ToCString(), value%, size%)
End Function

Function xSurfaceEffectFloatArray(surface%, name:String, value%, size%)
	xSurfaceEffectFloatArray_(surface%, String(name).ToCString(), value%, size%)
End Function

Function xSurfaceEffectMatrixArray(surface%, name:String, value%, size%)
	xSurfaceEffectMatrixArray_(surface%, String(name).ToCString(), value%, size%)
End Function

Function xSurfaceEffectEntityMatrix(surface%, name:String, matrix%)
	xSurfaceEffectEntityMatrix_(surface%, String(name).ToCString(), matrix%)
End Function

Function xSurfaceEffectMatrixSemantic(surface%, name:String, semantic%)
	xSurfaceEffectMatrixSemantic_(surface%, String(name).ToCString(), semantic%)
End Function

Function xDeleteSurfaceConstant(surface%, name:String)
	xDeleteSurfaceConstant_(surface%, String(name).ToCString())
End Function

'LogSys
Function xCreateLog%(target% = 1, level% = 0, filename:String = "log.html")
	Return xCreateLog_(target, level, String(filename).ToCString())
End Function

Function xGetLogString:String()
	Local CharSet:Byte Ptr = xGetLogString_()
	Local Name$, CharI%
	Repeat
		If CharSet[CharI]=Null Return Name
		Name:+Chr(Int(CharSet[CharI]))
		CharI:+1
	Forever
End Function

' joystick
Function xJoyType%(portID% = 0)
	Return xJoyType_(portID)
End Function

Function xJoyDown%(key%, portID% = 0)
	Return xJoyDown_(key, portID)
End Function

Function xJoyHit%(key%, portID% = 0)
	Return xJoyHit_(key, portID)
End Function

Function xGetJoy%(portID% = 0)
	Return xGetJoy_(portID)
End Function

Function xWaitJoy%(portID% = 0)
	Return xWaitJoy_(portID)
End Function

Function xJoyX#(portID% = 0)
	Return xJoyX_(portID)
End Function

Function xJoyY#(portID% = 0)
	Return xJoyY_(portID)
End Function

Function xJoyZ#(portID% = 0)
	Return xJoyZ_(portID)
End Function

Function xJoyU#(portID% = 0)
	Return xJoyU_(portID)
End Function

Function xJoyV#(portID% = 0)
	Return xJoyV_(portID)
End Function

Function xJoyPitch#(portID% = 0)
	Return xJoyPitch_(portID)
End Function

Function xJoyYaw#(portID% = 0)
	Return xJoyYaw_(portID)
End Function

Function xJoyRoll#(portID% = 0)
	Return xJoyRoll_(portID)
End Function

Function xJoyHat#(portID% = 0)
	Return xJoyHat_(portID)
End Function

Function xJoyXDir%(portID% = 0)
	Return xJoyXDir_(portID)
End Function

Function xJoyYDir%(portID% = 0)
	Return xJoyYDir_(portID)
End Function

Function xJoyZDir%(portID% = 0)
	Return xJoyZDir_(portID)
End Function

Function xJoyUDir%(portID% = 0)
	Return xJoyUDir_(portID)
End Function

Function xJoyVDir%(portID% = 0)
	Return xJoyVDir_(portID)
End Function

' deferred render
Function xInitDeferred(tex1% = 1, tex2% = 1, tex3% = 2, tex4 = 0)
	xInitDeferred_(tex1%, tex2%, tex3%, tex4)
End Function

Function xSetDeferredShaders(mrtShader:string, lightShader:string)
	xSetDeferredShaders_(String(mrtShader).ToCString(), String(lightShader).ToCString())
End Function

Function xRenderWorldDeferred(texture% = 0)
	xRenderWorldDeferred_(texture%)
End Function

' shadow system
Function xLightShadowEpsilons(light%, eps1#, eps2# = 0.16)
	xLightShadowEpsilons_(light%, eps1#, eps2#)
End Function

Function xSetShadowShader(path:string)
	xSetShadowShader_(String(path).ToCString())
End Function

Function xInitShadows(dirSize% = 512, spotSize% = 512, pointSize% = 128)
	xInitShadows_(dirSize%, spotSize%, pointSize%)
End Function

Function xSetShadowParams(splitPlanes% = 4, splitLambda# = 0.95, useOrtho% = True, lightDist# = 500.0)
	xSetShadowParams_(splitPlanes%, splitLambda#, useOrtho%, lightDist#)
End Function

' Main
Function xAppTitle(str:String) 
	xAppTitle_(String(str).ToCString()) 
End Function
Function xGraphics3D(width%,height%,depth% = 32,mode% = 0,vsync% = 0) 
	xGraphics3D_(width,height,depth,mode,vsync) 
	xDefaultFont = xLoadFont("Arial") 
End Function
Function xRenderWorld(tween% = 1) 
	xRenderWorld_(tween) 
End Function
Function xUpdateWorld(speed# = 1.0) 
	xUpdateWorld_(speed) 
End Function
Function xGetFunctionAddress%(str:String)
	Return xGetFunctionAddress_(String(str).ToCString())
End Function

Function xSetEffectEntityTexture(ent%, name:String, index%)
	xSetEffectEntityTexture_(ent, String(name).ToCString(), index)
End Function

Function xLoadMeshAsync%(path:String, parent% = 0)
	Return xLoadMeshAsync_(String(path).ToCString(), parent)
End Function

Function xLoadMeshInThread(path:String, parent% = 0)
	Return xLoadMeshInThread_(String(path).ToCString(), parent)
End Function

Function xLoadMeshWithChild%(path:String, parent% = 0)
	Return xLoadMeshWithChild_(String(path).ToCString(), parent)
End Function

Function xLoadTextureInThread%(path:String, flag%)
	Return xLoadTextureInThread_(String(path).ToCString(), flag)
End Function

Function xLoadTextureInRAM%(path:String)
	Return xLoadTextureInRAM_(String(path).ToCString())
End Function

' Input
Global Mouse_key_li%[] = New Int[8] 
Function xMouseHit2%(Key%) 
	If xMouseDown(Key) <> 0 Mouse_key_li[Key] = 1 ElseIf Mouse_key_li[Key] = 1 Mouse_key_li[Key] = 0 Return 1
End Function


' Mesh
Function xLoadMesh%(path:Byte Ptr,parent% = 0) 
	Return xLoadMesh_(path,parent) 
End Function
Function xLoadAnimMesh%(path:Byte Ptr,parent% = 0) 
	Return xLoadAnimMesh_(path,parent) 
End Function
Function xLoadDXmesh%(path:Byte Ptr,optimizeType% = 0,parent% = 0) 
	Return xLoadDXmesh_(path,optimizeType,parent) 
End Function

Function xCreateMesh%(parent% = 0) 
	Return xCreateMesh_(parent) 
End Function
Function xCopyMesh%(entity%,parent% = 0) 
	Return xCopyMesh_%(entity%,parent%) 
End Function

Function xCreateCube(parent = 0) 
	Return xCreateCube_(parent) 
End Function
Function xCreateSphere%(seg% = 32,parent% = 0) 
	Return xCreateSphere_(seg,parent) 
End Function
Function xCreateCylinder%(seg% = 32,SOLID% = 1,parent% = 0) 
	Return xCreateCylinder_(seg,SOLID,parent) 
End Function
Function xCreatePivot%(parent% = 0) 
	Return xCreatePivot_(parent) 
End Function
Function xCreateCone%(seg% = 32,SOLID% = 1,parent% = 0) 
	Return xCreateCone_(seg,SOLID,parent) 
End Function


' Entity
Function xEntityParent(entity%,parent%,isglobal% = 0) 
	xEntityParent_(entity,parent,isglobal) 
End Function
Function xCopyEntity%(entity%,parent% = 0,cloneBuff%=1) 
	Return xCopyEntity_(entity,parent,cloneBuff) 
End Function

Function xVideoInfo:String()
	Local CharSet:Byte Ptr = xVideoInfo_()
	Local Name$, CharI%
	Repeat
		If CharSet[CharI]=Null Return Name
		Name:+Chr(Int(CharSet[CharI]))
		CharI:+1
	Forever
End Function

Function xCPUName:String()
	Local CharSet:Byte Ptr = xCPUName_()
	Local Name$, CharI%
	Repeat
		If CharSet[CharI]=Null Return Name
		Name:+Chr(Int(CharSet[CharI]))
		CharI:+1
	Forever
End Function

Function xCPUVendor:String()
	Local CharSet:Byte Ptr = xCPUVendor_()
	Local Name$, CharI%
	Repeat
		If CharSet[CharI]=Null Return Name
		Name:+Chr(Int(CharSet[CharI]))
		CharI:+1
	Forever
End Function

Function xEntityName:String(entity%)
	Local CharSet:Byte Ptr=xEntityName_(entity)
	Local Name$,CharI%
	
	Repeat
		If CharSet[CharI]=Null Return Name
		Name:+Chr(Int(CharSet[CharI]))
		CharI:+1
	Forever
End Function
Function xEntityClass:String(entity%)
	Local CharSet:Byte Ptr=xEntityClass_(entity)
	Local Name$,CharI%
	
	Repeat
		If CharSet[CharI]=Null Return Name
		Name:+Chr(Int(CharSet[CharI]))
		CharI:+1
	Forever
End Function
Function xEntityPickMode(entity%,mode% = 0,obsc% = 1) 
	xEntityPickMode_(entity%,mode%,obsc%) 
End Function

Function xPositionEntity(entity%,x#,y#,z#,isGlobal% = 0) 
	xPositionEntity_(entity,x,y,z,isGlobal) 
End Function
Function xMoveEntity(entity%,x#,y#,z#,isGlobal% = 0) 
	xMoveEntity_(entity,x,y,z,isGlobal) 
End Function
Function xTranslateEntity(entity%,x#,y#,z#,isGlobal% = 0) 
	xTranslateEntity_(entity%,x#,y#,z#,isGlobal%) 
End Function
Function xEntityX#(entity%,isGlobal% = 0) 
	Return xEntityX_(entity,isGlobal) 
End Function
Function xEntityY#(entity%,isGlobal% = 0) 
	Return xEntityY_(entity,isGlobal) 
End Function
Function xEntityZ#(entity%,isGlobal% = 0) 
	Return xEntityZ_(entity,isGlobal) 
End Function

Function xScaleEntity(entity%,x#,y#,z#,isGlobal% = 0) 
	xScaleEntity_(entity,x,y,z,isGlobal) 
End Function

Function xRotateEntity(entity%,x#,y#,z#,isGlobal% = 0) 
	xRotateEntity_(entity,x,y,z,isGlobal) 
End Function
Function xTurnEntity(entity%,x#,y#,z#,isGlobal% = 0) 
	xTurnEntity_(entity,x,y,z,isGlobal) 
End Function
Function xPointEntity(ent1%,ent2%,Roll# = 0) 
	xPointEntity_(ent1%,ent2,Roll) 
End Function
Function xEntityRoll#(entity%,isGlobal% = 0) 
	Return xEntityRoll_#(entity,isGlobal) 
End Function
Function xEntityYaw#(entity%,isGlobal% = 0) 
	Return xEntityYaw_#(entity,isGlobal) 
End Function
Function xEntityPitch#(entity,isGlobal% = 0) 
	Return xEntityPitch_#(entity,isGlobal) 
End Function


' Texture
Function xLoadTexture%(path:Byte Ptr,flag% = 0) 
	Return xLoadTexture_(path,flag) 
End Function
Function xCreateTexture%(w%,h%,fl% = 9,fr% = 1) 
	Return xCreateTexture_(w,h,fl,fr) 
End Function
Function xEntityTexture(entity%,tex%,Frame% = 0,index% = 0) 
	xEntityTexture_(entity,tex,Frame,index) 
End Function
Function xTextureName:String(tex%)
	Local CharSet:Byte Ptr=xTextureName_(tex)
	Local Name$,CharI%
	
	Repeat
		If CharSet[CharI]=Null Return Name
		Name:+Chr(Int(CharSet[CharI]))
		CharI:+1
	Forever
End Function


' Camera
Function xCreateCamera%(parent% = 0) 
	Return xCreateCamera_(parent) 
End Function


' Image
Function xCreateImage%(w%,h%,f% = 1) 
	Return xCreateImage_%(w%,h%,f%) 
End Function
Function xSaveImage(img%,path:Byte Ptr,Frame% = 0) 
	xSaveImage_(img%,path,Frame%) 
End Function

Function xDrawImage(img%,x%,y%,Frame% = 0) 
	xDrawImage_(img%,x%,y%,Frame%) 
End Function
Function xDrawImageRect(img%,x%,y%,rx%,ry%,rw%,rh%,Frame% = 0) 
	xDrawImageRect_(img%,x%,y%,rx%,ry%,rw%,rh%,Frame%) 
End Function
Function xTileImage(img%,x% = 0,y% = 0,f% = 0) 
	xTileImage_(img%,x%,y%,f%) 
End Function


' Pixel
Function xWritePixel(x%,y%,argb%,buff% = -1) 
	xWritePixel_(x%,y%,argb%,buff%) 
End Function
Function xWritePixelFast(x%,y%,argb%,buff% = -1) 
	xWritePixelFast_(x%,y%,argb%,buff%) 
End Function
Function xReadPixel:Long(x%,y%,buff% = -1) 
	Return xReadPixel_:Long(x%,y%,buff%) 
End Function
Function xReadPixelFast%(x%,y%,buff% = -1) 
	Return xReadPixelFast_%(x%,y%,buff%)
End Function
Function xCopyPixel(sx%,sy%,sbuf%,dx%,dy%,dbuf% = -1) 
	xCopyPixel_(sx%,sy%,sbuf%,dx%,dy%,dbuf%) 
End Function
Function xCopyPixelFast(sx%,sy%,sbuf%,dx%,dy%,dbuf% = -1) 
	xCopyPixelFast_(sx%,sy%,sbuf%,dx%,dy%,dbuf%) 
End Function


' Particle
Function xCreateParticleSystem%(tex% = 0,Frame% = 0,minps# = 10.0,maxps# = 10.0,parent% = 0) 
	Return xCreateParticleSystem_%(tex%,Frame%,minps#,maxps#,parent%) 
End Function
Function xParticleSystemTexture(entity%,tex% = 0,Frame% = 0) 
	xParticleSystemTexture_(entity,tex%,Frame%) 
End Function
Function xCreateParticle%(psys%,plife% = -1) 
	Return xCreateParticle_%(psys%,plife%) 
End Function


' Surface
Function xCreateSurface%(MESH%,brush% = 0) 
	Return xCreateSurface_%(MESH%,brush%) 
End Function
Function xClearSurface(surf%,verts% = 1,tris% = 1) 
	xClearSurface_(surf%,verts%,tris%) 
End Function


' Vertices
Function xAddVertex%(surf%,x#,y#,z#,u# = 0,v# = 0,w# = 0) 
	Return xAddVertex_(surf,x,y,z,u,v,w) 
End Function
Function xVertexTexCoords(surf%,ver%,u#,v#,w# = 0,tset% = 0) 
	xVertexTexCoords_(surf%,ver%,u#,v#,w#,tset%) 
End Function
Function xVertexU#(surf%,vert%,tset% = 0) 
	Return xVertexU_#(surf%,vert%,tset%) 
End Function
Function xVertexV#(surf%,vert%,tset% = 0) 
	Return xVertexV_#(surf%,vert%,tset%) 
End Function
Function xVertexW#(surf%,vert%,tset% = 0) 
	Return xVertexW_#(surf%,vert%,tset%) 
End Function


' Animation
Function xAnimate(entity%,mode% = 1,speed# = 1.0,se% = 0,trans% = 0,root:String = "") 
	xAnimate_(entity,mode,speed,se,trans,root) 
End Function
Function xLoadAnimSeq%(entity%,path:String = "") 
	Return xLoadAnimSeq_%(entity,path) 
End Function
Function xExtractAnimSeq%(entity%,ff%,fl%,seq% = 0) 
	Return xExtractAnimSeq_(entity,ff,fl,seq) 
End Function

Function xSetAnimTime(entity%,time#,root:String = "") 
	Return xSetAnimTime_(entity,time#,root) 
End Function
Function xAnimTime#(entity%,root:String = "") 
	Return xAnimTime_#(entity,root) 
End Function
Function xAnimSeq%(entity%,root:String = "") 
	Return xAnimSeq_%(entity,root) 
End Function
Function xAnimLength#(entity%,root:String = "") 
	Return xAnimLength_#(entity,root) 
End Function
Function xSetAnimSpeed(entity%,speed#,rootBone:String = "") 
	Return xSetAnimSpeed_(entity%,speed#,rootBone) 
End Function
Function xAnimSpeed#(entity%,rootBone:String = "") 
	Return xAnimSpeed_#(entity%,rootBone) 
End Function

Function xAnimating%(entity%,root:String = "") 
	Return xAnimating_%(entity,root) 
End Function


' Light
Function xCreateLight%(lType% = 1) 
	Return xCreateLight_(lType) 
End Function


' PostEffect
Function xSetPostEffect(peza%,index% = 0) 
	xSetPostEffect_(peza,index) 
End Function
Function xSetPostEffectVectorF(pe%,Name:Byte Ptr,x#,y#,z#,w# = 1.0) 
	xSetPostEffectVector_(pe%,Name,x#,y#,z#,w#) 
End Function
Function xSetPostEffectVector(pe%,Name:Byte Ptr,vec:Vector4D) 
	xSetPostEffectVector_(pe%,Name,vec.x#,vec.y#,vec.z#,vec.w#) 
End Function


' Pixel\Vertex Shader
Function xSetPixelShaderVectorF(entity%,Name:Byte Ptr,x#,y#,z#,w# = 1.0) 
	xSetPixelShaderVector_(entity,Name,x,y,z,w) 
End Function	
Function xSetPixelShaderVector(entity%,Name:Byte Ptr,vector:Vector4D) 
	xSetPixelShaderVector_(entity,Name,vector.x#,vector.y#,vector.z#,vector.w#) 
End Function
Function xSetVertexShaderVectorF(entity%,Name:Byte Ptr,x#,y#,z#,w# = 1.0) 
	xSetVertexShaderVector_(entity,Name,x,y,z,w) 
End Function
Function xSetVertexShaderVector(entity%,Name:Byte Ptr,vector:Vector4D) 
	xSetVertexShaderVector_(entity,Name,vector.x#,vector.y#,vector.z#,vector.w#) 
End Function
Function xSetPixelShaderTexture(entity%,Name:Byte Ptr,tex%,Frame% = 0) 
	xSetPixelShaderTexture_(entity,Name,tex,Frame) 
End Function
Function xSetPixelShaderEntityTexture(entity%,Name:Byte Ptr,index% = 0) 
	xSetPixelShaderEntityTexture_(entity,Name,index%) 
End Function


' Shader
Function xGetMaxPixelShaderVersionStr:String() 
	Select xGetMaxPixelShaderVersion() 
		Case 0
			Return "1.1"
		Case 1
			Return "1.2"
		Case 2
			Return "1.3"
		Case 3
			Return "1.4"
		Case 4
			Return "2.0"
		Case 5
			Return "3.0"
		Default
			Return "unsuported"
	EndSelect
End Function
Function xGetMaxVertexShaderVersionStr:String() 
	Select xGetMaxVertexShaderVersion() 
		Case 0
			Return "1.1"
		Case 1
			Return "2.0"
		Case 2
			Return "3.0"
		Default
			Return "unsuported"
	EndSelect
End Function


' Terrain
Function xLoadTerrain%(path:Byte Ptr,parent% = 0) 
	Return xLoadTerrain_(path,parent) 
End Function
Function xCreateTerrain%(Size%,parent% = 0) 
	Return xCreateTerrain_%(Size%,parent%) 
End Function
Function xModifyTerrain(entity%,x%,y%,h#,rt% = 0) 
	xModifyTerrain_(entity,x%,y%,h#,rt%) 
End Function


' Brush
Function xLoadBrush%(path:Byte Ptr,flags% = 1,xs# = 1.0,ys# = 1.0) 
	Return xLoadBrush_%(path,flags%,xs#,ys#) 
End Function
Function xCreateBrush%(r# = 255,g# = 255,b# = 255) 
	Return xCreateBrush_(r#,g#,b#) 
End Function
Function xBrushTexture(b%,t%,f% = 0,i% = 0) 
	xBrushTexture_(b,t,f,i) 
End Function


' Image,2D
Function xImageBuffer%(img%,Frame% = 0) 
	Return xImageBuffer_(img,Frame) 
End Function
Function xTextureBuffer%(tex%,Frame% = 0) 
	Return xTextureBuffer_(tex,Frame) 
End Function

Function xRect(x1%,y1%,x2%,y2%,SOLID% = 0) 
	xRect_(x1%,y1%,x2%,y2%,SOLID%) 
End Function
Function xOval(x%,y%,w%,h%,SOLID% = 0) 
	xOval_(x%,y%,w%,h%,SOLID%) 
End Function
Function xText(x%,y%,dText:Byte Ptr,cx% = 0,cy% = 0) 
	xText_(x,y,dText,cx,cy) 
End Function


' FX Shader
Function xSetEffectTexture(entity%,Name:Byte Ptr,tex%,Frame% = 0) 
	xSetEffectTexture_(entity,Name,tex,Frame) 
End Function
Function xSetEffectVector(entity%,Name:Byte Ptr,vec:Vector4D) 
	Return xSetEffectVector_(entity,Name,vec.x#,vec.y#,vec.z#,vec.w#) 
End Function
Function xSetEffectVectorF(entity%,Name:Byte Ptr,x#,y#,z#,w# = 1.0) 
	Return xSetEffectVector_(entity,Name,x,y,z,w) 
End Function


' Sprite
Function xLoadSprite%(path:Byte Ptr,flags% = 1,parent% = 0) 
	Return xLoadSprite_%(path,flags%,parent%) 
End Function


' Other
Function xLinePick%(x#,y#,z#,dx#,dy#,dz#,dist# = 0) 
	Return xLinePick_%(x#,y#,z#,dx#,dy#,dz#,dist#) 
End Function
Function xAlignToVector(entity%,x#,y#,z#,a%,f# = 1.0) 
	xAlignToVector_(entity,x#,y#,z#,a%,f#) 
End Function
Function xCreateListener%(parent%,rolloffFactor# = 1.0,dopplerScale# = 1.0,distanceScale# = 1.0) 
	Return xCreateListener_%(parent%,rolloffFactor#,dopplerScale#,distanceScale#) 
End Function
Function xLoadFont%(FONT:Byte Ptr,Height% = 12,bold% = 0,italic% = 0,underline% = 0) 
	Return xLoadFont_(FONT,height,bold,italic,underline) 
End Function

'Log levels
Const LOG_NO		= 5
Const LOG_FATAL		= 4
Const LOG_ERROR		= 3
Const LOG_WARNING	= 2
Const LOG_MESSAGE	= 1
Const LOG_INFO		= 0

'Log targets
Const LOG_HTML				= 1
Const LOG_COUT				= 2
Const LOG_HTML_COUT			= 3
Const LOG_STRING			= 4
Const LOG_HTML_STRING		= 5
Const LOG_COUT_STRING		= 6
Const LOG_HTML_COUT_STRING	= 7

' Skining Methods
Const SKIN_HARDWARE		= 0
Const SKIN_HARDWAREVS	= 1
Const SKIN_SOFTWARE		= 2

' Light Types
Const LIGHT_DIRECTIONAL	= 1
Const LIGHT_POINT		= 2
Const LIGHT_SPOT		= 3

' Texture Filtration Types
Const TF_NONE			= 0
Const TF_POINT			= 1
Const TF_LINEAR			= 2
Const TF_ANISOTROPIC	= 3
Const TF_ANISOTROPICX4	= 4
Const TF_ANISOTROPICX8	= 5
Const TF_ANISOTROPICX16	= 6

' Vertex Shader Versions
Const VS_1_1 = 0
Const VS_2_0 = 1
Const VS_3_0 = 2

' Pixel Shader Versions
Const PS_1_1 = 0
Const PS_1_2 = 1
Const PS_1_3 = 2
Const PS_1_4 = 3
Const PS_2_0 = 4
Const PS_3_0 = 5

' Matrix Types
Const WORLD                         = 0
Const WORLDVIEWPROJ                 = 1
Const VIEWPROJ                      = 2
Const VIEW                          = 3
Const PROJ                          = 4
Const WORLDVIEW                     = 5
Const VIEWINVERSE                   = 6
Const ADDITIONAL1                   = 7
Const ADDITIONAL2                   = 8
Const ADDITIONAL3                   = 9
Const ADDITIONAL4                   = 10
Const ADDITIONAL5                   = 11
Const ADDITIONAL6                   = 12
Const ADDITIONAL7                   = 13
Const ADDITIONAL8                   = 14
Const WORLDINVERSETRANSPOSE         = 15
Const WORLDINVERSE                  = 16
Const WORLDTRANSPOSE                = 17
Const VIEWPROJINVERSE               = 18
Const VIEWPROJINVERSETRANSPOSE      = 19
Const VIEWTRANSPOSE                 = 20
Const VIEWINVRSETRANSPOSE           = 21
Const PROJINVERSE                   = 22
Const PROJTRANSPOSE                 = 23
Const PROJINVRSETRANSPOSE           = 24
Const WORLDVIEWPROJTRANSPOSE        = 25
Const WORLDVIEWPROJINVERSE          = 26
Const WORLDVIEWPROJINVERSETRANSPOSE = 27
Const WORLDVIEWTRANSPOSE            = 28
Const WORLDVIEWINVERSE              = 29
Const WORLDVIEWINVERSETRANSPOSE     = 30

'AntiAlias Types
Const AANONE      = 0
Const AA2SAMPLES  = 1
Const AA3SAMPLES  = 2
Const AA4SAMPLES  = 3
Const AA5SAMPLES  = 4
Const AA6SAMPLES  = 5
Const AA7SAMPLES  = 6
Const AA8SAMPLES  = 7
Const AA9SAMPLES  = 8
Const AA10SAMPLES = 9
Const AA11SAMPLES = 10
Const AA12SAMPLES = 11
Const AA13SAMPLES = 12
Const AA14SAMPLES = 13
Const AA15SAMPLES = 14
Const AA16SAMPLES = 15

' deferred surfaces formats
Const DEFERRED_NONE    = 0
Const DEFERRED_ARGB8   = 1
Const DEFERRED_R32F    = 2
Const DEFERRED_ARGB32F = 3
Const DEFERRED_GR16F   = 4
Const DEFERRED_RGB10A2 = 5

' Input Scancodes
Const xMOUSE_LEFT = 0
Const xMOUSE_RIGHT = 1
Const xMOUSE_MIDDLE = 2
Const xMOUSE4 = 3
Const xMOUSE5 = 4
Const xMOUSE6 = 5
Const xMOUSE7 = 6
Const xMOUSE8 = 7
Const xKEY_ESCAPE = 1
Const xKEY_1 = 2
Const xKEY_2 = 3
Const xKEY_3 = 4
Const xKEY_4 = 5
Const xKEY_5 = 6
Const xKEY_6 = 7
Const xKEY_7 = 8
Const xKEY_8 = 9
Const xKEY_9 = 10
Const xKEY_0 = 11
Const xKEY_MINUS = 12
Const xKEY_EQUALS = 13
Const xKEY_BACK = 14
Const xKEY_TAB = 15
Const xKEY_Q = 16
Const xKEY_W = 17
Const xKEY_E = 18
Const xKEY_R = 19
Const xKEY_T = 20
Const xKEY_Y = 21
Const xKEY_U = 22
Const xKEY_I = 23
Const xKEY_O = 24
Const xKEY_P = 25
Const xKEY_LBRACKET = 26
Const xKEY_RBRACKET = 27
Const xKEY_RETURN = 28
Const xKEY_LCONTROL = 29
Const xKEY_RCONTROL = 157
Const xKEY_A = 30
Const xKEY_S = 31
Const xKEY_D = 32
Const xKEY_F = 33
Const xKEY_G = 34
Const xKEY_H = 35
Const xKEY_J = 36
Const xKEY_K = 37
Const xKEY_L = 38
Const xKEY_SEMICOLON = 39
Const xKEY_APOSTROPHE = 40
Const xKEY_GRAVE = 41
Const xKEY_LSHIFT = 42
Const xKEY_BACKSLASH = 43
Const xKEY_Z = 44
Const xKEY_X = 45
Const xKEY_C = 46
Const xKEY_V = 47
Const xKEY_B = 48
Const xKEY_N = 49
Const xKEY_M = 50
Const xKEY_COMMA = 51
Const xKEY_PERIOD = 52
Const xKEY_SLASH = 53
Const xKEY_RSHIFT = 54
Const xKEY_MULTIPLY = 55
Const xKEY_MENU = 56
Const xKEY_SPACE = 57
Const xKEY_F1 = 59
Const xKEY_F2 = 60
Const xKEY_F3 = 61
Const xKEY_F4 = 62
Const xKEY_F5 = 63
Const xKEY_F6 = 64
Const xKEY_F7 = 65
Const xKEY_F8 = 66
Const xKEY_F9 = 67
Const xKEY_F10 = 68
Const xKEY_NUMLOCK       = 69
Const xKEY_SCROLL = 70
Const xKEY_NUMPAD7 = 71
Const xKEY_NUMPAD8 = 72
Const xKEY_NUMPAD9 = 73
Const xKEY_SUBTRACT = 74
Const xKEY_NUMPAD4 = 75
Const xKEY_NUMPAD5 = 76
Const xKEY_NUMPAD6 = 77
Const xKEY_ADD = 78
Const xKEY_NUMPAD1 = 79
Const xKEY_NUMPAD2 = 80
Const xKEY_NUMPAD3 = 81
Const xKEY_NUMPAD0 = 82
Const xKEY_DECIMAL = 83
Const xKEY_TILD = 86
Const xKEY_F11 = 87
Const xKEY_F12 = 88
Const xKEY_NUMPADENTER = 156
Const xKEY_RMENU = 221
Const xKEY_PAUSE = 197
Const xKEY_HOME = 199
Const xKEY_UP = 200
Const xKEY_PRIOR = 201
Const xKEY_LEFT = 203
Const xKEY_RIGHT = 205
Const xKEY_END = 207
Const xKEY_DOWN = 208
Const xKEY_NEXT = 209
Const xKEY_INSERT = 210
Const xKEY_DELETE = 211
Const xKEY_LWIN = 219
Const xKEY_RWIN = 220
Const xKEY_BACKSPACE = xKEY_BACK
Const xKEY_NUMPADSTAR = xKEY_MULTIPLY
Const xKEY_LALT = 184
Const xKEY_CAPSLOCK = 58
Const xKEY_NUMPADMINUS = xKEY_SUBTRACT
Const xKEY_NUMPADPLUS = xKEY_ADD
Const xKEY_NUMPADPERIOD = xKEY_DECIMAL
Const xKEY_DIVIDE = 181
Const xKEY_NUMPADSLASH = xKEY_DIVIDE
Const xKEY_RALT = 56
Const xKEY_UPARROW = xKEY_UP
Const xKEY_PGUP = xKEY_PRIOR
Const xKEY_LEFTARROW = xKEY_LEFT
Const xKEY_RIGHTARROW = xKEY_RIGHT
Const xKEY_DOWNARROW = xKEY_DOWN
Const xKEY_PGDN = xKEY_NEXT

' Camera fog mode
Const FOG_NONE     = 0
Const FOG_LINEAR   = 1

' Camera projection mode
Const PROJ_DISABLE		= 0
Const PROJ_PERSPECTIVE	= 1
Const PROJ_ORTHOGRAPHIC = 2

' Entity FX flags
Const FX_NOTHING		= 0
Const FX_FULLBRIGHT		= 1
Const FX_VERTEXCOLOR	= 2
Const FX_FLATSHEDED		= 4
Const FX_DISABLEFOG		= 8
Const FX_DISABLECULLING	= 16

' Entity blending modes
Const BLEND_ALPHA		= 1
Const BLEND_MULTIPLY	= 2
Const BLEND_ADD			= 3

' Compare functions
Const CMP_NEVER			= 1
Const CMP_LESS			= 2
Const CMP_EQUAL			= 3
Const CMP_LESSEQUAL		= 4
Const CMP_GREATER		= 5
Const CMP_NOTEQUAL		= 6
Const CMP_GREATEREQUAL	= 7
Const CMP_ALWAYS		= 8

' Axis
Const AXIS_X	= 1
Const AXIS_Y	= 2
Const AXIS_Z	= 3

' Texture loading flags
Const FLAGS_COLOR			= 1
Const FLAGS_ALPHA			= 2
Const FLAGS_MASKED			= 4
Const FLAGS_MIPMAPPED		= 8
Const FLAGS_CLAMPU			= 16
Const FLAGS_CLAMPV			= 32
Const FLAGS_SPHERICALENVMAP	= 64
Const FLAGS_CUBICENVMAP		= 128
Const FLAGS_R32F			= 256
Const FLAGS_RESERVED		= 512
Const FLAGS_VOLUMETEXTURE	= 1024
Const FLAGS_ARBG16F			= 2048
Const FLAGS_ARBG32F			= 4096

' Texture blending modes
Const TEXBLEND_NONE			 = 0
Const TEXBLEND_ALPHA		 = 1
Const TEXBLEND_MULTIPLY		 = 2
Const TEXBLEND_ADD			 = 3
Const TEXBLEND_DOT3			 = 4
Const TEXBLEND_LIGHTMAP		 = 5
Const TEXBLEND_SEPARATEALPHA = 6

' Cube map faces
Const FACE_LEFT		= 0
Const FACE_FORWARD	= 1
Const FACE_RIGHT	= 2
Const FACE_BACKWARD = 3
Const FACE_UP		= 4
Const FACE_DOWN		= 5

' Entity animation types
Const ANIMATION_STOP		= 0
Const ANIMATION_LOOP		= 1
Const ANIMATION_PINGPONG	= 2
Const ANIMATION_ONE			= 3

' Collision types
Const SPHERETOSHPHERE		= 1
Const SPHERETOBOX			= 2
Const SPHERETOTRIMESH		= 3

' Collision respones types
Const RESPONSE_STOP				= 1
Const RESPONSE_SLIDING			= 2
Const RESPONSE_SLIDING_DOWNLOCK	= 3

' Entity picking modes
Const PICK_NONE			= 0
Const PICK_SPHERE		= 1
Const PICK_TRIMESH		= 2
Const PICK_BOX			= 3

' Sprite view modes
Const SPRITE_FIXED		 = 1
Const SPRITE_FREE		 = 2
Const SPRITE_FREEROLL	 = 3
Const SPRITE_FIXEDYAW	 = 4

' X-files optimization types
Const OPTIMIZE_VERTEXCACHE	= 1
Const OPTIMIZE_STRIPREORDER = 2
Const OPTIMIZE_ATTRSORT		= 3

' Joystick types
Const JOY_NONE		= 0
Const JOY_DIGITAL	= 1
Const JOY_ANALOG	= 2