/**************************************************************************
*                                                                        *
* xScript official header for C\C++. CopyRight 2009 Xors3D Team          *
* WWW: http://www.xors3d.com                                             *
* E-Mail: support@xors3d.com                                             *
*                                                                        *
* Xors3D headers  is distributed in the hope that it will be useful, but *
* WITHOUT ANY WARRANTY.  No author or distributor accepts responsibility *
* to anyone for the  consequences of using  it or for  whether it serves *
* any particular purpose or works at all, unless he says so in writing.  *
*                                                                        *
**************************************************************************/
#ifndef _XSCRIPT_H_
#define _XSCRIPT_H_

// functions declaration & call types
#define XDECL extern "C" __declspec(dllexport)
#define XCALL _stdcall 

// types defines
typedef int Script;

XDECL Script		XCALL xLoadScript(const char * fileName);
XDECL bool			XCALL xExecuteScript(Script script, const char * entryPoint = "int main()");
XDECL void			XCALL xDeleteScript(Script script);
XDECL void			XCALL xSetIntegerVariable(Script script, const char * varName, int value);
XDECL int			XCALL xGetIntegerVariable(Script script, const char * varName);
XDECL void			XCALL xSetFloatVariable(Script script, const char * varName, float value);
XDECL float			XCALL xGetFloatVariable(Script script, const char * varName);
XDECL void			XCALL xSetStringVariable(Script script, const char *  varName, const char * value);
XDECL const char *	XCALL xGetStringVariable(Script script, const char * varName);
XDECL void			XCALL xRegisterFunction(const char * decl, void * funcAddr);
XDECL void			XCALL xSetIntegerArg(int index, int value);
XDECL void			XCALL xSetFloatArg(int index, float value);
XDECL void			XCALL xSetStringArg(int index, const char * value);
XDECL int			XCALL xGetIntegerReturn();
XDECL float			XCALL xGetFloatReturn();
XDECL const char *	XCALL xGetStringReturn();

INLINE void BindXors3D();

#endif